GNU bug report logs - #48696
[PATCH 0/3] Documenting commit reverts and revocation

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix-patches; Reported by: Ludovic Courtès <ludo@HIDDEN>; Keywords: patch; dated Thu, 27 May 2021 12:34:02 UTC; Maintainer for guix-patches is guix-patches@HIDDEN.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 13 Jun 2021 10:15:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 13 06:15:55 2021
Received: from localhost ([127.0.0.1]:42690 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lsN9m-0002aY-Fe
	for submit <at> debbugs.gnu.org; Sun, 13 Jun 2021 06:15:54 -0400
Received: from eggs.gnu.org ([209.51.188.92]:41852)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lsN9j-0002SL-0B
 for 48696 <at> debbugs.gnu.org; Sun, 13 Jun 2021 06:15:51 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38712)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lsN9d-0001vG-Hf; Sun, 13 Jun 2021 06:15:45 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=55286 helo=gnu.org)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lsN9d-0002w0-AL; Sun, 13 Jun 2021 06:15:45 -0400
From: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
To: 48696 <at> debbugs.gnu.org
Subject: [PATCH v2 2/4] doc: Add "Addressing Issues" section.
Date: Sun, 13 Jun 2021 12:15:36 +0200
Message-Id: <20210613101538.10668-3-ludo@HIDDEN>
X-Mailer: git-send-email 2.32.0
In-Reply-To: <20210613101538.10668-1-ludo@HIDDEN>
References: <87lf7g7azx.fsf@HIDDEN>
 <20210613101538.10668-1-ludo@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>,
 Christopher Baines <mail@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

* doc/contributing.texi (Addressing Mistakes): New section.

Co-authored-by: Christopher Baines <mail@HIDDEN>
---
 doc/contributing.texi | 39 +++++++++++++++++++++++++++++++++++++++
 1 file changed, 39 insertions(+)

diff --git a/doc/contributing.texi b/doc/contributing.texi
index 4ab489173b..00962be11e 100644
--- a/doc/contributing.texi
+++ b/doc/contributing.texi
@@ -1419,6 +1419,45 @@ you're confident, it's OK to commit.
 That last part is subject to being adjusted, allowing individuals to commit
 directly on non-controversial changes on parts they’re familiar with.
 
+@subsection Addressing Issues
+
+Peer review (@pxref{Submitting Patches}) and tools such as
+@command{guix lint} (@pxref{Invoking guix lint}) and the test suite
+(@pxref{Running the Test Suite}) should catch issues before they are
+pushed.  Yet, commits that ``break'' functionality might occasionally
+go through.  When that happens, there are two priorities: mitigating
+the impact, and understanding what happened to reduce the chance of
+similar incidents in the future.  The responsibility for both these
+things primarily lies with those involved, but like everything this is
+a group effort.
+
+Some issues can directly affect all users---for instance because they
+make @command{guix pull} fail or break core functionality, because they
+break major packages (at build time or run time), or because they
+introduce known security vulnerabilities.
+
+@cindex reverting commits
+The people involved in authoring, reviewing, and pushing such
+commit(s) should be at the forefront to mitigate their impact in a
+timely fashion: by pushing a followup commit to fix it (if possible),
+or by reverting it to leave time to come up with a proper fix, and by
+communicating with other developers about the problem.
+
+If these persons are unavailable to address the issue in time, other
+committers are entitled to revert the commit(s), explaining in the
+commit log and on the mailing list what the problem was, with the goal
+of leaving time to the original committer, reviewer(s), and author(s)
+to propose a way forward.
+
+Once the problem has been dealt with, it is the responsibility of
+those involved to make sure the situation is understood.  If you are
+working to understand what happened, focus on gathering information
+and avoid assigning any blame.  Do ask those involved to describe what
+happened, do not ask them to explain the situation---this would
+implicitly blame them, which is unhelpful.  Accountability comes from
+a consensus about the problem, learning from it and improving
+processes so that it's less likely to reoccur.
+
 @subsection Commit Revocation
 
 In order to reduce the possibility of mistakes, committers will have
-- 
2.32.0





Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 13 Jun 2021 10:15:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 13 06:15:55 2021
Received: from localhost ([127.0.0.1]:42694 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lsN9n-0002bM-BV
	for submit <at> debbugs.gnu.org; Sun, 13 Jun 2021 06:15:55 -0400
Received: from eggs.gnu.org ([209.51.188.92]:41866)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lsN9j-0002TK-PX
 for 48696 <at> debbugs.gnu.org; Sun, 13 Jun 2021 06:15:52 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38718)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lsN9e-0001w3-Jh; Sun, 13 Jun 2021 06:15:46 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=55286 helo=gnu.org)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lsN9e-0002w0-CQ; Sun, 13 Jun 2021 06:15:46 -0400
From: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
To: 48696 <at> debbugs.gnu.org
Subject: [PATCH v2 4/4] doc: Clarify Git commit signing; fix typo.
Date: Sun, 13 Jun 2021 12:15:38 +0200
Message-Id: <20210613101538.10668-5-ludo@HIDDEN>
X-Mailer: git-send-email 2.32.0
In-Reply-To: <20210613101538.10668-1-ludo@HIDDEN>
References: <87lf7g7azx.fsf@HIDDEN>
 <20210613101538.10668-1-ludo@HIDDEN>
MIME-Version: 1.0
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Suggested by Maxime Devos <maximedevos@HIDDEN>
and Julien Lepiller <julien@HIDDEN>.

* doc/contributing.texi (Commit Access): Clarify Git commit signing
setup and fix typo.
---
 doc/contributing.texi | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/doc/contributing.texi b/doc/contributing.texi
index 5e59278534..a8bc279936 100644
--- a/doc/contributing.texi
+++ b/doc/contributing.texi
@@ -1367,11 +1367,13 @@ commits, run:
 
 @example
 git config commit.gpgsign true
+
+# Substitute the fingerprint of your public PGP key.
 git config user.signingkey CABBA6EA1DC0FF33
 @end example
 
 You can prevent yourself from accidentally pushing unsigned commits to
-Savannah by using the pre-push Git hook called located at
+Savannah by using the pre-push Git hook located at
 @file{etc/git/pre-push}:
 
 @example
-- 
2.32.0





Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 13 Jun 2021 10:15:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 13 06:15:55 2021
Received: from localhost ([127.0.0.1]:42692 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lsN9m-0002b2-VX
	for submit <at> debbugs.gnu.org; Sun, 13 Jun 2021 06:15:55 -0400
Received: from eggs.gnu.org ([209.51.188.92]:41860)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lsN9j-0002Sc-8b
 for 48696 <at> debbugs.gnu.org; Sun, 13 Jun 2021 06:15:52 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38714)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lsN9e-0001vt-2j; Sun, 13 Jun 2021 06:15:46 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=55286 helo=gnu.org)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lsN9d-0002w0-RX; Sun, 13 Jun 2021 06:15:46 -0400
From: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
To: 48696 <at> debbugs.gnu.org
Subject: [PATCH v2 3/4] doc: Explain more reasons for commit revocation.
Date: Sun, 13 Jun 2021 12:15:37 +0200
Message-Id: <20210613101538.10668-4-ludo@HIDDEN>
X-Mailer: git-send-email 2.32.0
In-Reply-To: <20210613101538.10668-1-ludo@HIDDEN>
References: <87lf7g7azx.fsf@HIDDEN>
 <20210613101538.10668-1-ludo@HIDDEN>
MIME-Version: 1.0
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

* doc/contributing.texi (Commit Revocation): Expound.
---
 doc/contributing.texi | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

diff --git a/doc/contributing.texi b/doc/contributing.texi
index 00962be11e..5e59278534 100644
--- a/doc/contributing.texi
+++ b/doc/contributing.texi
@@ -1466,6 +1466,27 @@ key removed from @file{.guix-authorizations} after 12 months of
 inactivity; they can ask to regain commit access by emailing the
 maintainers, without going through the vouching process.
 
+Maintainers@footnote{See @uref{https://guix.gnu.org/en/about} for the
+current list of maintainers.  You can email them privately at
+@email{guix-maintainers@@gnu.org}.} may also revoke an individual's
+commit rights, as a last resort, if cooperation with the rest of the
+community has caused too much friction---even within the bounds of the
+project's code of conduct (@pxref{Contributing}).  They would only do so
+after public or private discussion with the individual and a clear
+notice.  Examples of behavior that hinders cooperation and could lead to
+such a decision include:
+
+@itemize
+@item repeated violation of the commit policy stated above;
+@item repeated failure to take peer criticism into account;
+@item breaching trust through a series of grave incidents.
+@end itemize
+
+When maintainers resort to such a decision, they notify developers on
+@email{guix-devel@@gnu.org}; inquiries may be sent to
+@email{guix-maintainers@@gnu.org}.  Depending on the situation, the
+individual may still be welcome to contribute.
+
 @subsection Helping Out
 
 One last thing: the project keeps moving forward because committers not
-- 
2.32.0





Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 13 Jun 2021 10:15:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 13 06:15:54 2021
Received: from localhost ([127.0.0.1]:42688 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lsN9l-0002Zy-Mr
	for submit <at> debbugs.gnu.org; Sun, 13 Jun 2021 06:15:54 -0400
Received: from eggs.gnu.org ([209.51.188.92]:41848)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lsN9i-0002Ri-FI
 for 48696 <at> debbugs.gnu.org; Sun, 13 Jun 2021 06:15:51 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38710)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lsN9c-0001um-UI; Sun, 13 Jun 2021 06:15:44 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=55286 helo=gnu.org)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lsN9c-0002w0-Mj; Sun, 13 Jun 2021 06:15:44 -0400
From: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
To: 48696 <at> debbugs.gnu.org
Subject: [PATCH v2 1/4] doc: Structure the "Commit Access" section.
Date: Sun, 13 Jun 2021 12:15:35 +0200
Message-Id: <20210613101538.10668-2-ludo@HIDDEN>
X-Mailer: git-send-email 2.32.0
In-Reply-To: <20210613101538.10668-1-ludo@HIDDEN>
References: <87lf7g7azx.fsf@HIDDEN>
 <20210613101538.10668-1-ludo@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

* doc/contributing.texi (Commit Access): Add introduction and section
heading.  Separate OpenPGP setup from commit policy.
---
 doc/contributing.texi | 59 ++++++++++++++++++++++++++++---------------
 1 file changed, 38 insertions(+), 21 deletions(-)

diff --git a/doc/contributing.texi b/doc/contributing.texi
index d67e632520..4ab489173b 100644
--- a/doc/contributing.texi
+++ b/doc/contributing.texi
@@ -1275,8 +1275,19 @@ this nifty tool!
 @section Commit Access
 
 @cindex commit access, for developers
-For frequent contributors, having write access to the repository is
-convenient.  When you deem it necessary, consider applying for commit
+Everyone can contribute to Guix without having commit access
+(@pxref{Submitting Patches}).  However, for frequent contributors,
+having write access to the repository can be convenient.  Commit access
+should not be thought of as a ``badge of honor'' but rather as a
+responsibility a contributor is willing to take to help the project.
+
+The following sections explain how to get commit access, how to be ready
+to push commits, and the policies and community expectations for commits
+pushed upstream.
+
+@subsection Applying for Commit Access
+
+When you deem it necessary, consider applying for commit
 access by following these steps:
 
 @enumerate
@@ -1348,6 +1359,27 @@ review and merging system, which, as a consequence, may lead us to have
 fewer people with commit access to the main repository.  Stay tuned!
 @end quotation
 
+All commits that are pushed to the central repository on Savannah must
+be signed with an OpenPGP key, and the public key should be uploaded to
+your user account on Savannah and to public key servers, such as
+@code{keys.openpgp.org}.  To configure Git to automatically sign
+commits, run:
+
+@example
+git config commit.gpgsign true
+git config user.signingkey CABBA6EA1DC0FF33
+@end example
+
+You can prevent yourself from accidentally pushing unsigned commits to
+Savannah by using the pre-push Git hook called located at
+@file{etc/git/pre-push}:
+
+@example
+cp etc/git/pre-push .git/hooks/pre-push
+@end example
+
+@subsection Commit Policy
+
 If you get commit access, please make sure to follow
 the policy below (discussions of the policy can take place on
 @email{guix-devel@@gnu.org}).
@@ -1366,25 +1398,6 @@ mailing list for commit notifications (@email{guix-commits@@gnu.org}),
 so people can notice.  Before pushing your changes, make sure to run
 @code{git pull --rebase}.
 
-All commits that are pushed to the central repository on Savannah must
-be signed with an OpenPGP key, and the public key should be uploaded to
-your user account on Savannah and to public key servers, such as
-@code{keys.openpgp.org}.  To configure Git to automatically sign
-commits, run:
-
-@example
-git config commit.gpgsign true
-git config user.signingkey CABBA6EA1DC0FF33
-@end example
-
-You can prevent yourself from accidentally pushing unsigned commits to
-Savannah by using the pre-push Git hook called located at
-@file{etc/git/pre-push}:
-
-@example
-cp etc/git/pre-push .git/hooks/pre-push
-@end example
-
 When pushing a commit on behalf of somebody else, please add a
 @code{Signed-off-by} line at the end of the commit log message---e.g.,
 with @command{git am --signoff}.  This improves tracking of who did
@@ -1406,12 +1419,16 @@ you're confident, it's OK to commit.
 That last part is subject to being adjusted, allowing individuals to commit
 directly on non-controversial changes on parts they’re familiar with.
 
+@subsection Commit Revocation
+
 In order to reduce the possibility of mistakes, committers will have
 their Savannah account removed from the Guix Savannah project and their
 key removed from @file{.guix-authorizations} after 12 months of
 inactivity; they can ask to regain commit access by emailing the
 maintainers, without going through the vouching process.
 
+@subsection Helping Out
+
 One last thing: the project keeps moving forward because committers not
 only push their own awesome changes, but also offer some of their time
 @emph{reviewing} and pushing other people's changes.  As a committer,
-- 
2.32.0





Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 13 Jun 2021 10:15:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 13 06:15:53 2021
Received: from localhost ([127.0.0.1]:42686 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lsN9l-0002Zg-De
	for submit <at> debbugs.gnu.org; Sun, 13 Jun 2021 06:15:53 -0400
Received: from eggs.gnu.org ([209.51.188.92]:41844)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lsN9i-0002RZ-CY
 for 48696 <at> debbugs.gnu.org; Sun, 13 Jun 2021 06:15:51 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38708)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lsN9c-0001uO-Bj; Sun, 13 Jun 2021 06:15:44 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=55286 helo=gnu.org)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lsN9b-0002w0-SN; Sun, 13 Jun 2021 06:15:44 -0400
From: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
To: 48696 <at> debbugs.gnu.org
Subject: [PATCH v2 0/4] Documenting commit reverts and revocation
Date: Sun, 13 Jun 2021 12:15:34 +0200
Message-Id: <20210613101538.10668-1-ludo@HIDDEN>
X-Mailer: git-send-email 2.32.0
In-Reply-To: <87lf7g7azx.fsf@HIDDEN>
References: <87lf7g7azx.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi!

Changes since the initial version:

  1. “Addressing Mistakes” section replaced by “Addressing Issues”
     following suggestions by Chris Baines at
     <https://issues.guix.gnu.org/48696#17>.

  2. Fix typo and clarify Git commit signing instructions as
     reported by Julien and Maxime (these were in pre-existing
     text).

If there are no objections, I’d like to push within a couple of
days.

Thanks,
Ludo’.

Ludovic Courtès (4):
  doc: Structure the "Commit Access" section.
  doc: Add "Addressing Issues" section.
  doc: Explain more reasons for commit revocation.
  doc: Clarify Git commit signing; fix typo.

 doc/contributing.texi | 121 ++++++++++++++++++++++++++++++++++--------
 1 file changed, 100 insertions(+), 21 deletions(-)

-- 
2.32.0





Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 11 Jun 2021 14:05:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jun 11 10:05:23 2021
Received: from localhost ([127.0.0.1]:39765 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lrhmk-0007ec-SW
	for submit <at> debbugs.gnu.org; Fri, 11 Jun 2021 10:05:23 -0400
Received: from eggs.gnu.org ([209.51.188.92]:33910)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lrhmi-0007eP-WB
 for 48696 <at> debbugs.gnu.org; Fri, 11 Jun 2021 10:05:21 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:57078)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lrhmd-0007Xn-CU; Fri, 11 Jun 2021 10:05:15 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=49316 helo=ribbon)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lrhmW-00063M-3F; Fri, 11 Jun 2021 10:05:15 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Christopher Baines <mail@HIDDEN>
Subject: Re: bug#48696: [PATCH 0/3] Documenting commit reverts and revocation
References: <20210527123554.4267-1-ludo@HIDDEN>
 <20210527123554.4267-2-ludo@HIDDEN> <87y2c0f0i4.fsf@HIDDEN>
 <87eedpet69.fsf@HIDDEN> <87k0ngfra8.fsf@HIDDEN>
 <87tumgwrhh.fsf_-_@HIDDEN> <87bl8gtpxk.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 23 Prairial an 229 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Fri, 11 Jun 2021 16:05:06 +0200
In-Reply-To: <87bl8gtpxk.fsf@HIDDEN> (Christopher Baines's message of
 "Tue, 08 Jun 2021 15:02:31 +0100")
Message-ID: <87lf7g7azx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Chris,

Christopher Baines <mail@HIDDEN> skribis:

> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

[...]

>>   @subsection Addressing Issues
>>
>>   Peer review (@pxref{Submitting Patches}) and tools such as
>>   @command{guix lint} (@pxref{Invoking guix lint}) and the test suite
>>   (@pxref{Running the Test Suite}) should catch issues before they are
>>   pushed.  Yet, commits that ``break'' functionality might occasionally
>>   go through.  When that happens, there are two priorities: mitigating
>>   the impact, and understanding what happened to reduce the chance of
>>   similar incidents in the future.  The responsibility for both these
>>   things primarily lies with those involved, but like everything this is
>>   a group effort.
>>=20=20=20
>>   Some issues can directly affect all users---for instance because they
>>   make @command{guix pull} fail or break core functionality, because they
>>   break major packages (at build time or run time), or because they
>>   introduce known security vulnerabilities.
>
> I'm not sure what this paragraph is getting at?

It=E2=80=99s supposed to be provide concrete guidance to a committer wonder=
ing
whether they can/should/are entitled to revert a given commit.

> In any case, for security vulnerabilities, to affect all users they
> would also have to occur in major packages.

Agreed.  The word =E2=80=9Cknown=E2=80=9D is important here: if I remove *-=
CVE-*.patch,
or if I downgrade a package, I=E2=80=99m likely introducing a =E2=80=9Cknow=
n=E2=80=9D
vulnerability; if I=E2=80=99m adding a new package that later happens to be
vulnerable, it=E2=80=99s not a =E2=80=9Cknown=E2=80=9D vulnerability (it=E2=
=80=99s just routine ;-)).

> I think the above text looks good. As noted above, I'm unsure about the
> second paragraph, but that's not a big issue.

OK, thanks for taking the time to discuss it.  I=E2=80=99ll send a v2 so
everyone gets a chance to chime in.

Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 8 Jun 2021 14:02:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 08 10:02:38 2021
Received: from localhost ([127.0.0.1]:59396 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lqcJR-0008P7-Lj
	for submit <at> debbugs.gnu.org; Tue, 08 Jun 2021 10:02:38 -0400
Received: from mira.cbaines.net ([212.71.252.8]:38432)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1lqcJQ-0008Oy-1w
 for 48696 <at> debbugs.gnu.org; Tue, 08 Jun 2021 10:02:36 -0400
Received: from localhost (unknown [IPv6:2a02:8010:68c1:0:8ac0:b4c7:f5c8:7caa])
 by mira.cbaines.net (Postfix) with ESMTPSA id E6CD027BC78;
 Tue,  8 Jun 2021 15:02:34 +0100 (BST)
Received: from capella (localhost [127.0.0.1])
 by localhost (OpenSMTPD) with ESMTP id d4ba3c70;
 Tue, 8 Jun 2021 14:02:34 +0000 (UTC)
References: <20210527123554.4267-1-ludo@HIDDEN>
 <20210527123554.4267-2-ludo@HIDDEN> <87y2c0f0i4.fsf@HIDDEN>
 <87eedpet69.fsf@HIDDEN> <87k0ngfra8.fsf@HIDDEN>
 <87tumgwrhh.fsf_-_@HIDDEN>
User-agent: mu4e 1.4.15; emacs 27.2
From: Christopher Baines <mail@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: bug#48696: [PATCH 0/3] Documenting commit reverts and revocation
In-reply-to: <87tumgwrhh.fsf_-_@HIDDEN>
Date: Tue, 08 Jun 2021 15:02:31 +0100
Message-ID: <87bl8gtpxk.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Hi Chris,
>
> Christopher Baines <mail@HIDDEN> skribis:
>
>> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>
> [...]
>
>>> I think you have a point though.  Could you propose different wording
>>> for this section?
>>>
>>> (My goal for this section was to (1) spell out circumstances that may
>>> lead to reverts, (2) explain the implications of committer
>>> accountability, and (3) define our community standards in terms of
>>> focusing on addressing issues and not on blaming individuals.)
>>
>> What I would like to see is more like this:
>>
>>   Problems happen, while minimising there occurrence is important, it's
>>   also important to respond to problems in a useful way. There are two
>>   priorities, mitigating the impact and understanding what happened in
>>   order to reduce the chance of similar incidents in the future. The
>>   responsibility for both these things primarily lies with those
>>   involved, but like everything this is a group effort.
>>
>>   When working to mitigate the impact of a problem, obviously the
>>   response is very much dependent on the situation. If it's possible to
>>   fix things that are broken, that's preferable. If that's infeasible,
>>   then promptly reverting changes to return to a working state is
>>   justified (as with any commit, note why the change is being made in
>>   the commit message).
>>
>>   Once the problem has been dealt with to some extent, then it's the
>>   responsibility of those involved to make sure the situation is
>>   understood. If you are working to understand what happened, focus on
>>   gathering information and avoid assigning any blame. Do ask those
>>   involved to describe what has happened, don't ask them to explain the
>>   situation, even if you think they have something to explain, as this
>>   implicitly blames them, which is unhelpful. Accountability comes from
>>   a consensus about the problem, learning from it and improving
>>   processes so that it's less likely to reoccur.
>>
>> I'm not sure how much needs saying about reverts, but I did include
>> something.
>>
>> For committer accountability, that's where I'm talking about the
>> "responsibilities of those involved". I guess that's a little vague, but
>> what I'm trying to do there is trying to capture the group of relevant
>> people, for example, the person who proposed the breaking change, the
>> committer who pushed it, and the other person that reverted it.
>>
>> In terms of trying to focus on addressing issues and not blaming
>> individuals, I think just avoiding language that implicitly blames
>> people would be a big step forward. Whether that's enough, I'm unsure.
>
> OK.
>
> I like what you wrote; I think it addresses #3 and a bit of #2 above,
> but I find a bit too abstract, not sufficiently hands-on (when can
> commits be reverted? what=E2=80=99s the timeframe? who=E2=80=99s involved=
?), and lacking
> examples.  =E2=80=9CProblems happen=E2=80=9D sounds unspecific to me (it =
reminds me of
> Forest Gump :-)) and I=E2=80=99m uncomfortable with the passive voice tha=
t tends
> to erase individuals.
>
>   @subsection Addressing Issues
>
>   Peer review (@pxref{Submitting Patches}) and tools such as
>   @command{guix lint} (@pxref{Invoking guix lint}) and the test suite
>   (@pxref{Running the Test Suite}) should catch issues before they are
>   pushed.  Yet, commits that ``break'' functionality might occasionally
>   go through.  When that happens, there are two priorities: mitigating
>   the impact, and understanding what happened to reduce the chance of
>   similar incidents in the future.  The responsibility for both these
>   things primarily lies with those involved, but like everything this is
>   a group effort.
>=20=20=20
>   Some issues can directly affect all users---for instance because they
>   make @command{guix pull} fail or break core functionality, because they
>   break major packages (at build time or run time), or because they
>   introduce known security vulnerabilities.

I'm not sure what this paragraph is getting at?

In any case, for security vulnerabilities, to affect all users they
would also have to occur in major packages.

>   @cindex reverting commits
>   The people involved in authoring, reviewing, and pushing such
>   commit(s) should be at the forefront to mitigate their impact in a
>   timely fashion: by pushing a followup commit to fix it (if possible),
>   or by reverting it to leave time to come up with a proper fix, and by
>   communicating with other developers about the problem.
>=20=20=20
>   If these persons are unavailable to address the issue in time, other
>   committers are entitled to revert the commit(s), explaining in the
>   commit log and on the mailing list what the problem was, with the goal
>   of leaving time to the original committer, reviewer(s), and author(s)
>   to propose a way forward.
>=20=20=20
>   Once the problem has been dealt with, it is the responsibility of
>   those involved to make sure the situation is understood.  If you are
>   working to understand what happened, focus on gathering information
>   and avoid assigning any blame.  Do ask those involved to describe what
>   happened, do not ask them to explain the situation---this would
>   implicitly blame them, which is unhelpful.  Accountability comes from
>   a consensus about the problem, learning from it and improving
>   processes so that it's less likely to reoccur.
>
> There=E2=80=99s still =E2=80=9Cthe people involved=E2=80=9D, =E2=80=9Cthe=
se persons=E2=80=9D, and =E2=80=9Csuch commits=E2=80=9D
> (I removed =E2=80=9Cfaulty=E2=80=9D), because I couldn=E2=80=99t think of=
 a way of avoiding
> these without making the text too abstract or dismissing the idea
> entirely (the idea that if I push a breaking change, others can expect
> me to be spend time =E2=80=9Cmitigating the effort=E2=80=9D).
>
> Also, I think it=E2=80=99s useful to distinguish between =E2=80=9CI rever=
t my commit=E2=80=9D
> and =E2=80=9Csomeone reverts my commit=E2=80=9D due to their different so=
cial and
> emotional implications (our goal is precisely to suggest that these
> implications are out of place in this group effort that Guix is, but we
> can=E2=80=99t deny that they preexist).
>
> WDYT?

I think the above text looks good. As noted above, I'm unsure about the
second paragraph, but that's not a big issue.

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQKlBAEBCgCPFiEEPonu50WOcg2XVOCyXiijOwuE9XcFAmC/eHdfFIAAAAAALgAo
aXNzdWVyLWZwckBub3RhdGlvbnMub3BlbnBncC5maWZ0aGhvcnNlbWFuLm5ldDNF
ODlFRUU3NDU4RTcyMEQ5NzU0RTBCMjVFMjhBMzNCMEI4NEY1NzcRHG1haWxAY2Jh
aW5lcy5uZXQACgkQXiijOwuE9XfDTA/8DCO0CBrXvyvu5JlgJqJIzeoH9Wf5gv5N
PRMaF4uCbcLE5DiFg9RYgy1UpYedqbSXx1Cfr6mmJw/t5ObaIBrOsnqAO9FF1+2T
j91A9x9nTY/kkP0Cq0r96JNIX7l/ht3REeEYwUrtS4Gw0lE8zK6PZck8LPNGDopu
hHfM8P/BxpREpAhvPhTsb2VSv8z8HC1qGhW587DRGbW9WlNr/qADVMqOhpvu4K3g
5Be8J+wbv5E4DrkV9d5tSN0SSMCg0MsaixoO44iQqilSTNhkRic2BEV1YGRq9JyZ
1RocMBpTPBYnOjiK/vSySoSDkk8aSEnb2mL6HosXXYfFyYvhbeXHJw8LFkcr/wor
ayJ55WFzKVO6CPSX9v7WgVtl6Aupl0sOxlLLq3gR6jHDeuZNWGjpAX/BBMeeijiJ
VyRr7zVRDC85RyXxJokVSlXECbqO3xuOyJbTZP7yvc4sSO3gffHyMQQ/6GUX0cKK
CGjdyTBCqpF4d9dWULtV1n87h8OcUrzkszCbPXjjZ+eQTQjkytiUPiGSAoz/EDs5
0hqjDCo1qpcfIMUOkEjolv8U0CfMjU4lZ83V6MGiRPCfCFzezh+ZSqHEp8qk/RG0
qamW4+XnEOFMrH4VB78i2C/sbnWlxyyRif8I9NMwNH7WDWl6i4Svb/Lr9rO5zVSr
znXKZm6Jzzo=
=YZ9K
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 2 Jun 2021 09:22:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 02 05:22:43 2021
Received: from localhost ([127.0.0.1]:38886 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1loN5H-0006sc-B6
	for submit <at> debbugs.gnu.org; Wed, 02 Jun 2021 05:22:43 -0400
Received: from eggs.gnu.org ([209.51.188.92]:35278)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1loN5F-0006sM-Iv
 for 48696 <at> debbugs.gnu.org; Wed, 02 Jun 2021 05:22:42 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:40764)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1loN5A-0005XO-B4; Wed, 02 Jun 2021 05:22:36 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=58798 helo=ribbon)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1loN5A-0004ry-2p; Wed, 02 Jun 2021 05:22:36 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Christopher Baines <mail@HIDDEN>
Subject: Re: bug#48696: [PATCH 0/3] Documenting commit reverts and revocation
References: <20210527123554.4267-1-ludo@HIDDEN>
 <20210527123554.4267-2-ludo@HIDDEN> <87y2c0f0i4.fsf@HIDDEN>
 <87eedpet69.fsf@HIDDEN> <87k0ngfra8.fsf@HIDDEN>
Date: Wed, 02 Jun 2021 11:22:34 +0200
In-Reply-To: <87k0ngfra8.fsf@HIDDEN> (Christopher Baines's message of
 "Sun, 30 May 2021 11:29:51 +0100")
Message-ID: <87tumgwrhh.fsf_-_@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Chris,

Christopher Baines <mail@HIDDEN> skribis:

> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

[...]

>> I think you have a point though.  Could you propose different wording
>> for this section?
>>
>> (My goal for this section was to (1) spell out circumstances that may
>> lead to reverts, (2) explain the implications of committer
>> accountability, and (3) define our community standards in terms of
>> focusing on addressing issues and not on blaming individuals.)
>
> What I would like to see is more like this:
>
>   Problems happen, while minimising there occurrence is important, it's
>   also important to respond to problems in a useful way. There are two
>   priorities, mitigating the impact and understanding what happened in
>   order to reduce the chance of similar incidents in the future. The
>   responsibility for both these things primarily lies with those
>   involved, but like everything this is a group effort.
>
>   When working to mitigate the impact of a problem, obviously the
>   response is very much dependent on the situation. If it's possible to
>   fix things that are broken, that's preferable. If that's infeasible,
>   then promptly reverting changes to return to a working state is
>   justified (as with any commit, note why the change is being made in
>   the commit message).
>
>   Once the problem has been dealt with to some extent, then it's the
>   responsibility of those involved to make sure the situation is
>   understood. If you are working to understand what happened, focus on
>   gathering information and avoid assigning any blame. Do ask those
>   involved to describe what has happened, don't ask them to explain the
>   situation, even if you think they have something to explain, as this
>   implicitly blames them, which is unhelpful. Accountability comes from
>   a consensus about the problem, learning from it and improving
>   processes so that it's less likely to reoccur.
>
> I'm not sure how much needs saying about reverts, but I did include
> something.
>
> For committer accountability, that's where I'm talking about the
> "responsibilities of those involved". I guess that's a little vague, but
> what I'm trying to do there is trying to capture the group of relevant
> people, for example, the person who proposed the breaking change, the
> committer who pushed it, and the other person that reverted it.
>
> In terms of trying to focus on addressing issues and not blaming
> individuals, I think just avoiding language that implicitly blames
> people would be a big step forward. Whether that's enough, I'm unsure.

OK.

I like what you wrote; I think it addresses #3 and a bit of #2 above,
but I find a bit too abstract, not sufficiently hands-on (when can
commits be reverted? what=E2=80=99s the timeframe? who=E2=80=99s involved?)=
, and lacking
examples.  =E2=80=9CProblems happen=E2=80=9D sounds unspecific to me (it re=
minds me of
Forest Gump :-)) and I=E2=80=99m uncomfortable with the passive voice that =
tends
to erase individuals.

  @subsection Addressing Issues
=20=20
  Peer review (@pxref{Submitting Patches}) and tools such as
  @command{guix lint} (@pxref{Invoking guix lint}) and the test suite
  (@pxref{Running the Test Suite}) should catch issues before they are
  pushed.  Yet, commits that ``break'' functionality might occasionally
  go through.  When that happens, there are two priorities: mitigating
  the impact, and understanding what happened to reduce the chance of
  similar incidents in the future.  The responsibility for both these
  things primarily lies with those involved, but like everything this is
  a group effort.
=20=20
  Some issues can directly affect all users---for instance because they
  make @command{guix pull} fail or break core functionality, because they
  break major packages (at build time or run time), or because they
  introduce known security vulnerabilities.
=20=20
  @cindex reverting commits
  The people involved in authoring, reviewing, and pushing such
  commit(s) should be at the forefront to mitigate their impact in a
  timely fashion: by pushing a followup commit to fix it (if possible),
  or by reverting it to leave time to come up with a proper fix, and by
  communicating with other developers about the problem.
=20=20
  If these persons are unavailable to address the issue in time, other
  committers are entitled to revert the commit(s), explaining in the
  commit log and on the mailing list what the problem was, with the goal
  of leaving time to the original committer, reviewer(s), and author(s)
  to propose a way forward.
=20=20
  Once the problem has been dealt with, it is the responsibility of
  those involved to make sure the situation is understood.  If you are
  working to understand what happened, focus on gathering information
  and avoid assigning any blame.  Do ask those involved to describe what
  happened, do not ask them to explain the situation---this would
  implicitly blame them, which is unhelpful.  Accountability comes from
  a consensus about the problem, learning from it and improving
  processes so that it's less likely to reoccur.

There=E2=80=99s still =E2=80=9Cthe people involved=E2=80=9D, =E2=80=9Cthese=
 persons=E2=80=9D, and =E2=80=9Csuch commits=E2=80=9D
(I removed =E2=80=9Cfaulty=E2=80=9D), because I couldn=E2=80=99t think of a=
 way of avoiding
these without making the text too abstract or dismissing the idea
entirely (the idea that if I push a breaking change, others can expect
me to be spend time =E2=80=9Cmitigating the effort=E2=80=9D).

Also, I think it=E2=80=99s useful to distinguish between =E2=80=9CI revert =
my commit=E2=80=9D
and =E2=80=9Csomeone reverts my commit=E2=80=9D due to their different soci=
al and
emotional implications (our goal is precisely to suggest that these
implications are out of place in this group effort that Guix is, but we
can=E2=80=99t deny that they preexist).

WDYT?

Thanks for taking the time to work on it!

Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 30 May 2021 12:48:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 30 08:48:17 2021
Received: from localhost ([127.0.0.1]:58506 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lnKrZ-00032b-Bj
	for submit <at> debbugs.gnu.org; Sun, 30 May 2021 08:48:17 -0400
Received: from tobias.gr ([80.241.217.52]:43206)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <me@HIDDEN>) id 1lnKrX-00032O-35
 for 48696 <at> debbugs.gnu.org; Sun, 30 May 2021 08:48:15 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tobias.gr; s=2018;
 bh=UoFBU9IV5OlUFR6zDHhmKvmN5YmVdZOxpHmXMeWveIY=; h=date:in-reply-to:
 subject:cc:to:from:references; b=OxdnfoznlTt7E5DWJM6cFejXwgWdK4I35S+vv
 VVDOv3Y6kNE/zRo5apm62QemepkAt9BCTPBtjsyM2V50GkXeOYkHi/9i4CbOHTxd3JXMAg
 D8XeeJGpet9dw8cRtKYwWYPiPTxCp8a2/fqVEkoAaetHOhuG5xaYMMk14bbjk6++snHR+d
 2Bro0/THmfAe9dBYBDARWYuQSqT2ZP0uleVbfrNn011EpmETsILiEBJVfr2ZIswppzsT3j
 Q+ob48Y0I4yNpqdd0+okoTSH3h1IVSwXz3kzcuYNSZcJPM1+yAzzkXtfOZEQIGktYtD8zf
 oDLVuud4XVLtHCfupyDC8vH5Q==
Received: by submission.tobias.gr (OpenSMTPD) with ESMTPSA id b9fc44b1
 (TLSv1.2:ECDHE-ECDSA-AES256-GCM-SHA384:256:NO); 
 Sun, 30 May 2021 12:48:12 +0000 (UTC)
References: <20210527123259.4115-1-ludo@HIDDEN>
From: Tobias Geerinckx-Rice <me@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#48696] [PATCH 0/3] Documenting commit reverts and revocation
In-reply-to: <20210527123259.4115-1-ludo@HIDDEN>
BIMI-Selector: v=BIMI1; s=default;
Date: Sun, 30 May 2021 14:49:00 +0200
Message-ID: <87wnrgs7yb.fsf@nckx>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org, guix-patches@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: quoted-printable

Ludovic Court=C3=A8s =E5=86=99=E9=81=93=EF=BC=9A
> It essentially codifies unwritten rules, but as always, I think=20
> it=E2=80=99s
> better to be explicit about the rules and community=20
> expectations.

Looks good to me modulo obvious typos like the =E2=80=98called=E2=80=99 poi=
nted=20
out by Julien.

I *don't* think the text assigns too much potential blame.=20
Responsibility, yes.

Thanks Ludo'!

T G-R

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iIMEARYKACsWIQT12iAyS4c9C3o4dnINsP+IT1VteQUCYLOJvA0cbWVAdG9iaWFz
LmdyAAoJEA2w/4hPVW15nCEBAJCQXqDsk05JSkMY5Fred19XhZQwFpu20IHhvGNx
VXIvAP9H4Rt8mIq04zTr4/q3XVnhh7Pqj1PYLu5Z1xd8aIL+DQ==
=ifZ8
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 30 May 2021 12:48:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 30 08:48:28 2021
Received: from localhost ([127.0.0.1]:58509 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lnKrj-000330-IC
	for submit <at> debbugs.gnu.org; Sun, 30 May 2021 08:48:28 -0400
Received: from lists.gnu.org ([209.51.188.17]:33416)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <me@HIDDEN>) id 1lnKrg-00032q-3V
 for submit <at> debbugs.gnu.org; Sun, 30 May 2021 08:48:26 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:47078)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <me@HIDDEN>) id 1lnKrf-0002UI-18
 for guix-patches@HIDDEN; Sun, 30 May 2021 08:48:23 -0400
Received: from tobias.gr ([2a02:c205:2020:6054::1]:48040)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <me@HIDDEN>)
 id 1lnKrb-0004mD-Gp; Sun, 30 May 2021 08:48:22 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tobias.gr; s=2018;
 bh=UoFBU9IV5OlUFR6zDHhmKvmN5YmVdZOxpHmXMeWveIY=; h=date:in-reply-to:
 subject:cc:to:from:references; b=OxdnfoznlTt7E5DWJM6cFejXwgWdK4I35S+vv
 VVDOv3Y6kNE/zRo5apm62QemepkAt9BCTPBtjsyM2V50GkXeOYkHi/9i4CbOHTxd3JXMAg
 D8XeeJGpet9dw8cRtKYwWYPiPTxCp8a2/fqVEkoAaetHOhuG5xaYMMk14bbjk6++snHR+d
 2Bro0/THmfAe9dBYBDARWYuQSqT2ZP0uleVbfrNn011EpmETsILiEBJVfr2ZIswppzsT3j
 Q+ob48Y0I4yNpqdd0+okoTSH3h1IVSwXz3kzcuYNSZcJPM1+yAzzkXtfOZEQIGktYtD8zf
 oDLVuud4XVLtHCfupyDC8vH5Q==
Received: by submission.tobias.gr (OpenSMTPD) with ESMTPSA id b9fc44b1
 (TLSv1.2:ECDHE-ECDSA-AES256-GCM-SHA384:256:NO); 
 Sun, 30 May 2021 12:48:12 +0000 (UTC)
References: <20210527123259.4115-1-ludo@HIDDEN>
From: Tobias Geerinckx-Rice <me@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#48696] [PATCH 0/3] Documenting commit reverts and revocation
In-reply-to: <20210527123259.4115-1-ludo@HIDDEN>
BIMI-Selector: v=BIMI1; s=default;
Date: Sun, 30 May 2021 14:49:00 +0200
Message-ID: <87wnrgs7yb.fsf@nckx>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
Received-SPF: pass client-ip=2a02:c205:2020:6054::1; envelope-from=me@HIDDEN;
 helo=tobias.gr
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, SPF_HELO_PASS=-0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: 48696 <at> debbugs.gnu.org, guix-patches@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

--=-=-=
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: quoted-printable

Ludovic Court=C3=A8s =E5=86=99=E9=81=93=EF=BC=9A
> It essentially codifies unwritten rules, but as always, I think=20
> it=E2=80=99s
> better to be explicit about the rules and community=20
> expectations.

Looks good to me modulo obvious typos like the =E2=80=98called=E2=80=99 poi=
nted=20
out by Julien.

I *don't* think the text assigns too much potential blame.=20
Responsibility, yes.

Thanks Ludo'!

T G-R

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iIMEARYKACsWIQT12iAyS4c9C3o4dnINsP+IT1VteQUCYLOJvA0cbWVAdG9iaWFz
LmdyAAoJEA2w/4hPVW15nCEBAJCQXqDsk05JSkMY5Fred19XhZQwFpu20IHhvGNx
VXIvAP9H4Rt8mIq04zTr4/q3XVnhh7Pqj1PYLu5Z1xd8aIL+DQ==
=ifZ8
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 30 May 2021 10:30:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun May 30 06:30:07 2021
Received: from localhost ([127.0.0.1]:58443 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lnIhi-0005oh-CN
	for submit <at> debbugs.gnu.org; Sun, 30 May 2021 06:30:07 -0400
Received: from mira.cbaines.net ([212.71.252.8]:54842)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1lnIhg-0005oU-0G
 for 48696 <at> debbugs.gnu.org; Sun, 30 May 2021 06:29:57 -0400
Received: from localhost (unknown [IPv6:2a02:8010:68c1:0:8ac0:b4c7:f5c8:7caa])
 by mira.cbaines.net (Postfix) with ESMTPSA id C09CD27BC78;
 Sun, 30 May 2021 11:29:54 +0100 (BST)
Received: from capella (localhost [127.0.0.1])
 by localhost (OpenSMTPD) with ESMTP id 34b32d13;
 Sun, 30 May 2021 10:29:54 +0000 (UTC)
References: <20210527123554.4267-1-ludo@HIDDEN>
 <20210527123554.4267-2-ludo@HIDDEN> <87y2c0f0i4.fsf@HIDDEN>
 <87eedpet69.fsf@HIDDEN>
User-agent: mu4e 1.4.15; emacs 27.2
From: Christopher Baines <mail@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#48696] [PATCH 2/3] doc: Add "Addressing Mistakes" section.
In-reply-to: <87eedpet69.fsf@HIDDEN>
Date: Sun, 30 May 2021 11:29:51 +0100
Message-ID: <87k0ngfra8.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Hi Chris,
>
> Christopher Baines <mail@HIDDEN> skribis:
>
>> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>
> [...]
>
>>> +The Guix project values friendly cooperation and a constant effort to
>>> +focus on the way forward when issues arise.  Committers should lead by
>>> +example, notably as a way to encourage contributors and contributors to
>>> +be.  Blame as well as defensiveness do not have their place in Guix wh=
en
>>> +addressing genuine mistakes.
>>
>> I too would like to see less blame, but one factor is how things are
>> framed and the language used.
>
> Point taken!
>
>> On the language here, "mistake" is a word I would generally avoid if the
>> aim is avoid blaming someone, since mistakes are made by a person or set
>> of people. I'd prefer a term like "problem", since I don't perceieve
>> that as directly linked to a person or set of people.
>>
>> On the bit about the "person who pushed the faulty commits" (so, person
>> to blame...) I'd much prefer an emphisis on group responsibility to
>> mitigate the impact of problems quickly, and understand the factors that
>> led to that problems in the first place. That avoids assigning blame,
>> rather than the process pushing responsibility to the person to blame
>> ("person who pushed the faulty commit(s)").
>
> I get what you say and very much like the idea of focusing on group
> responsibility.
>
> There=E2=80=99s blame, and there=E2=80=99s accountability.  I see group r=
esponsibility
> in setting up processes and carrying out proper peer review to avoid
> problems.  I see accountability when it comes to commits actually
> pushed=E2=80=94in the end, it=E2=80=99s one person running =E2=80=98git p=
ush=E2=80=99.  In my view,
> =E2=80=9Cmistake=E2=80=9D can be a way to name a =E2=80=9Cproblem=E2=80=
=9D that someone created and is
> accountable for (Jelle wrote a nice message on this topic a while back).
> This is getting a bit philosophical though, and I=E2=80=99m not sure my
> understanding of English is good enough to go any further.  :-)

I guess part of what I'm getting at here is using language and the
perspective to try and delay that inference about individual
accountability, until the discussion around a problem has reached a
clear conclusion about what happened.

In doing so, opportunity is left open to actually consider the full
situation, rather than immediately narrowing it down to what a
particular individual or group did or didn't do.

> I think you have a point though.  Could you propose different wording
> for this section?
>
> (My goal for this section was to (1) spell out circumstances that may
> lead to reverts, (2) explain the implications of committer
> accountability, and (3) define our community standards in terms of
> focusing on addressing issues and not on blaming individuals.)

What I would like to see is more like this:

  Problems happen, while minimising there occurrence is important, it's
  also important to respond to problems in a useful way. There are two
  priorities, mitigating the impact and understanding what happened in
  order to reduce the chance of similar incidents in the future. The
  responsibility for both these things primarily lies with those
  involved, but like everything this is a group effort.

  When working to mitigate the impact of a problem, obviously the
  response is very much dependent on the situation. If it's possible to
  fix things that are broken, that's preferable. If that's infeasible,
  then promptly reverting changes to return to a working state is
  justified (as with any commit, note why the change is being made in
  the commit message).

  Once the problem has been dealt with to some extent, then it's the
  responsibility of those involved to make sure the situation is
  understood. If you are working to understand what happened, focus on
  gathering information and avoid assigning any blame. Do ask those
  involved to describe what has happened, don't ask them to explain the
  situation, even if you think they have something to explain, as this
  implicitly blames them, which is unhelpful. Accountability comes from
  a consensus about the problem, learning from it and improving
  processes so that it's less likely to reoccur.

I'm not sure how much needs saying about reverts, but I did include
something.

For committer accountability, that's where I'm talking about the
"responsibilities of those involved". I guess that's a little vague, but
what I'm trying to do there is trying to capture the group of relevant
people, for example, the person who proposed the breaking change, the
committer who pushed it, and the other person that reverted it.

In terms of trying to focus on addressing issues and not blaming
individuals, I think just avoiding language that implicitly blames
people would be a big step forward. Whether that's enough, I'm unsure.

>> On this same thread, I'd like to see less blaming in the form of asking
>> people to "explain". When there's a problem, and you ask someone to
>> explain, I would interpret that as "I'm blaming you for this, please
>> give your account of how the mistake was made", to which the person can
>> either answer explaining the details as to why they are to blame, or can
>> disagree with the implicit assertion that they are to blame. To avoid
>> assigning blame, one can just ask someone to "describe" what happened,
>> which I wouldn't interpret as being loaded with the same implicit
>> assertion.
>
> I agree with what you write in general, though my understanding is that
> you=E2=80=99re not referring to the text in this patch, right?

Yeah, although I think something to this effect might be worth
including.

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQKlBAEBCgCPFiEEPonu50WOcg2XVOCyXiijOwuE9XcFAmCzaR9fFIAAAAAALgAo
aXNzdWVyLWZwckBub3RhdGlvbnMub3BlbnBncC5maWZ0aGhvcnNlbWFuLm5ldDNF
ODlFRUU3NDU4RTcyMEQ5NzU0RTBCMjVFMjhBMzNCMEI4NEY1NzcRHG1haWxAY2Jh
aW5lcy5uZXQACgkQXiijOwuE9XePgRAAhu0dTc80nhZdC4GoRjBSJ4ZYelF6SXcn
hOaW1cALPeGzRCI1Pxw4ZYDHj+cYnvvR0GmkdlcKGjGjL19ILj4O8a0DH9gs3nd7
+94v4nT79uax+lvqUIXgark3s25m5TuRC4uNE6icQft5OoLmuzsYNq9cJPE+m4hU
B0RmTbrQtCPMLySWbLweCMGjbAfQ7CQJbqORCaMGNeRPf9QsLHNUppw2cny9GW/D
64rRaYKjFJofLAhhpb9dHr1ZM40YHWVtSO+akIIeT4nNfbxoqohJypl7QHeeP7ds
dBzyJ6t+08k5q4M6WJR5Frswb3SbvB9o9CGjXqxQ71Y8RGhND5X03xaXiLU2Hj95
Fq4P0LmAQP5TUxH4bzRn6Xv445FrBhR8u9NRyNXHAcRuRSQsE2Ck4YeocbWeOHkh
UZvGwOOP5+PVxIyirMHSOuLPyxLQgIvvkwzVNOdSrawqb/8biFQPSEtFQjxNQD64
5In3PUPGjLkdOaI8X73TnFl/QvuVyE4eNDhhQ+9PAKsmzr6EQlSAtxoQ85VaLviC
rVh0qogYwU7OdgZHFe6PfXxSQYAwH8LGaLWXJB/ZHFhfZ47MUBuBVHthXs9jfe68
MTtMTYfNeopg5XJbqs/kwUUp6ICnVyfUOm11QXFKksM3CGVs4XfzUtk8VEMPCRKU
wvyuU8XcFJE=
=8m4C
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 29 May 2021 20:36:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 29 16:36:56 2021
Received: from localhost ([127.0.0.1]:57774 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ln5hY-0000VB-EL
	for submit <at> debbugs.gnu.org; Sat, 29 May 2021 16:36:56 -0400
Received: from eggs.gnu.org ([209.51.188.92]:59674)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1ln5hW-0000Uz-Tt
 for 48696 <at> debbugs.gnu.org; Sat, 29 May 2021 16:36:55 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53536)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1ln5hR-0001C8-Bf; Sat, 29 May 2021 16:36:49 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=41326 helo=ribbon)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1ln5hR-0005ok-2I; Sat, 29 May 2021 16:36:49 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Christopher Baines <mail@HIDDEN>
Subject: Re: [bug#48696] [PATCH 3/3] doc: Explain more reasons for commit
 revocation.
References: <20210527123554.4267-1-ludo@HIDDEN>
 <20210527123554.4267-3-ludo@HIDDEN> <87v974ey8y.fsf@HIDDEN>
 <87k0nhg8uh.fsf@HIDDEN> <87sg25g4ni.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 10 Prairial an 229 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Sat, 29 May 2021 22:36:46 +0200
In-Reply-To: <87sg25g4ni.fsf@HIDDEN> (Christopher Baines's message of
 "Sat, 29 May 2021 12:28:49 +0100")
Message-ID: <87lf7x5lb5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -1.6 (-)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.6 (--)

Hello!

Christopher Baines <mail@HIDDEN> skribis:

> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

[...]

>> The section above is explicitly about cases where the individual did not
>> violate the code of conduct (hence =E2=80=9Ceven within the bounds of the
>> project's code of conduct=E2=80=9D in the text above), but instead broke
>> community expectations.
>
> I'd like to say that the code of conduct should encapsulate community
> expectations, but it does seem just to set out a strong position on
> harassment, and I would like to think that the community expectations
> are more than just making sure people feel that they're not being
> harassed.

Yes, that=E2=80=99s what the code of conduct is about, mostly.  It does not=
 say
how a development community should cooperate, how it can maximize
benefits for everyone involved.  I found this article by a Rust
developer inspiring:
<https://aturon.github.io/tech/2018/06/02/listening-part-2/>.

> Is your intent here for "community expectations" to be/remain abstract,
> or for them to be explicitly set out somewhere?

My intent with this patch is to spell out expectations for committers,
with a concrete implementation.  It=E2=80=99s one particular aspect of
=E2=80=9Ccommunity expectations=E2=80=9D, but one that I think ought to be =
written down,
because committers (and maintainers) have a higher responsibility.

>>> - Suspected malicious intent
>>
>> Put this way, the question becomes who is suspecting that.  Instead I
>> wrote =E2=80=9Cbreaching trust=E2=80=9D in the bullet list above; the in=
tent is to
>> describe a situation where the individual and other committers no longer
>> trust each other, there=E2=80=99s no judgment involved.
>
> I think the "who" here would be the people looking at removing someones
> commit access.

Removing someone=E2=80=99s commit access can never be a goal.  However,
maintainers, like everyone else, can witness a breach of trust at some
point.

> I like this framing because it's more specific than "breaching trust
> through a series of grave incidents". Do you have other things in mind
> that this third point as you put it would cover?

If repeated incidents happen, some may presume malice, while others may
still see =E2=80=9Cmere mistakes=E2=80=9D=E2=80=94we have different thresho=
lds.  Breach of trust
concerns the group as a whole: once there=E2=80=99s mutual suspicion among =
some
in the group, we can say that cooperation =E2=80=9Cdoesn=E2=80=99t work=E2=
=80=9D anymore, that
there=E2=80=99s too much friction.

>>> - Process problem for giving out commit access
>>
>> The process for giving commit access is already documented (info "(guix)
>> Commit Access"); my intent here was not to change it.
>
> My point here is just that I think it's reasonable to remove someones
> commit access if it was effectively given out in error (because the
> process wasn't followed properly, or has been since revised).

Oh, got it.  To me it=E2=80=99s implicit that commit access can only be obt=
ained
by following the documented process (that=E2=80=99s indeed be the case since
it=E2=80=99s in place); do you think we should be more explicit?

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 29 May 2021 11:28:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 29 07:28:56 2021
Received: from localhost ([127.0.0.1]:56222 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmx9E-0005Mo-CE
	for submit <at> debbugs.gnu.org; Sat, 29 May 2021 07:28:56 -0400
Received: from mira.cbaines.net ([212.71.252.8]:52724)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1lmx9C-0005Me-BQ
 for 48696 <at> debbugs.gnu.org; Sat, 29 May 2021 07:28:54 -0400
Received: from localhost (unknown [IPv6:2a02:8010:68c1:0:8ac0:b4c7:f5c8:7caa])
 by mira.cbaines.net (Postfix) with ESMTPSA id 3F99427BC78;
 Sat, 29 May 2021 12:28:53 +0100 (BST)
Received: from capella (localhost [127.0.0.1])
 by localhost (OpenSMTPD) with ESMTP id 0d8a2f96;
 Sat, 29 May 2021 11:28:52 +0000 (UTC)
References: <20210527123554.4267-1-ludo@HIDDEN>
 <20210527123554.4267-3-ludo@HIDDEN> <87v974ey8y.fsf@HIDDEN>
 <87k0nhg8uh.fsf@HIDDEN>
User-agent: mu4e 1.4.15; emacs 27.2
From: Christopher Baines <mail@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#48696] [PATCH 3/3] doc: Explain more reasons for commit
 revocation.
In-reply-to: <87k0nhg8uh.fsf@HIDDEN>
Date: Sat, 29 May 2021 12:28:49 +0100
Message-ID: <87sg25g4ni.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Christopher Baines <mail@HIDDEN> skribis:
>
>> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>
> [...]
>
>>> +Maintainers@footnote{See @uref{https://guix.gnu.org/en/about} for the
>>> +current list of maintainers.  You can email them privately at
>>> +@email{guix-maintainers@@gnu.org}.} may also revoke an individual's
>>> +commit rights, as a last resort, if cooperation with the rest of the
>>> +community has caused too much friction---even within the bounds of the
>>> +project's code of conduct (@pxref{Contributing}).  They would only do =
so
>>> +after public or private discussion with the individual and a clear
>>> +notice.  Examples of behavior that hinders cooperation and could lead =
to
>>> +such a decision include:
>>> +
>>> +@itemize
>>> +@item repeated violation of the commit policy stated above;
>>> +@item repeated failure to take peer criticism into account;
>>> +@item breaching trust through a series of grave incidents.
>>> +@end itemize
>
> [...]
>
>> Since the project code of conduct sets out behavioural standards,
>> including mandating "Gracefully accepting constructive criticism" and
>> "Showing empathy towards other community members", I think that combined
>> with "following the relevant processes" already covers what you're
>> setting out here?
>
> Note that the code of conduct does not =E2=80=9Cmandate=E2=80=9D graceful=
ly accepting
> constructive criticism; it merely gives it as an example of expected
> behavior.

Yeah, maybe you're right. While there's a pledge regarding harassment,
and the example behaviours are given in a section titled "Standards",
the example behaviours are called that, examples.

>> In abstract, in my opinion, I can only think of three scenarios for
>> removing someones commit access when they're actively using it:
>>
>> - Clear violation of the code of conduct
>
> Yes, that=E2=80=99s already covered by the code of conduct.
>
> The section above is explicitly about cases where the individual did not
> violate the code of conduct (hence =E2=80=9Ceven within the bounds of the
> project's code of conduct=E2=80=9D in the text above), but instead broke
> community expectations.

I'd like to say that the code of conduct should encapsulate community
expectations, but it does seem just to set out a strong position on
harassment, and I would like to think that the community expectations
are more than just making sure people feel that they're not being
harassed.

Is your intent here for "community expectations" to be/remain abstract,
or for them to be explicitly set out somewhere?

>> - Suspected malicious intent
>
> Put this way, the question becomes who is suspecting that.  Instead I
> wrote =E2=80=9Cbreaching trust=E2=80=9D in the bullet list above; the int=
ent is to
> describe a situation where the individual and other committers no longer
> trust each other, there=E2=80=99s no judgment involved.

I think the "who" here would be the people looking at removing someones
commit access.

I like this framing because it's more specific than "breaching trust
through a series of grave incidents". Do you have other things in mind
that this third point as you put it would cover?

>> - Process problem for giving out commit access
>
> The process for giving commit access is already documented (info "(guix)
> Commit Access"); my intent here was not to change it.

My point here is just that I think it's reasonable to remove someones
commit access if it was effectively given out in error (because the
process wasn't followed properly, or has been since revised).

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQKlBAEBCgCPFiEEPonu50WOcg2XVOCyXiijOwuE9XcFAmCyJXFfFIAAAAAALgAo
aXNzdWVyLWZwckBub3RhdGlvbnMub3BlbnBncC5maWZ0aGhvcnNlbWFuLm5ldDNF
ODlFRUU3NDU4RTcyMEQ5NzU0RTBCMjVFMjhBMzNCMEI4NEY1NzcRHG1haWxAY2Jh
aW5lcy5uZXQACgkQXiijOwuE9XfoXw/+OQWv8R3CjNHO3tOfhbcAjttGd2+DUAGK
9t+RdLEDQRtAhDC2TYv/+1iFcmEnTzKmSo0M1ea8wg/gt687nJ8qWE/2fJUstt/B
FiHk7G1Oj31uDWIADcMQ5YHvcdNz8SW9CG6YN6xHP3j2HEmE4yWUo3+VihuvOUHL
KqTUQvd1lZzF6IvubnlyBmqcE5As2R2qBUgM9462F/Dy+CT6ok9Rlh/dUjVRaCnJ
iqVdVBPUrp7UcG+ZqJKEgkWTcgC1eihIBfzDS0n96ozu9/Yz7XuF7kqKOuLglsaz
DR78tDVwlSk26pOxwwJbxvYaq7ZRsiGzujDVAUktHvZ7FS0r28imzF7Nq5PmJTJU
BnO2GVJPxZrSVgWgGBrQJKaxzrUSnmA6favoJSmlKNFJQlSWSpFOKYnRkjFViOV1
u/e0IuLDc3e63U0soaA3nBYnt/j17foN/s7bs3CbZH3QoSGYMmEHGZCw88RAqtqq
exJUE7eq10Leq05EdctGtrp7PspS4JappsLh2fL0zDNrLHVk3JWKUrprSY15kV6H
XWMaIhBxXCaUXVhTShLZjMoNo9ZxFOyufPugofQzx1FhiBDNPVWroRxkJ2aDHEue
67o8YYtQgeVfdIIK7NUQPx1iKQXGZtvEzF3Z1/CY8JThq6pKRTaFoSvBlQx+E+Q9
012iH8cplCk=
=4pVG
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 29 May 2021 10:22:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 29 06:22:18 2021
Received: from localhost ([127.0.0.1]:56047 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmw6j-0003Py-LG
	for submit <at> debbugs.gnu.org; Sat, 29 May 2021 06:22:17 -0400
Received: from eggs.gnu.org ([209.51.188.92]:49846)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lmw6h-0003Pl-JM
 for 48696 <at> debbugs.gnu.org; Sat, 29 May 2021 06:22:16 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:40020)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmw6a-0007Cy-5u; Sat, 29 May 2021 06:22:09 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=40196 helo=ribbon)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmw6Z-0006Qj-IP; Sat, 29 May 2021 06:22:08 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Christopher Baines <mail@HIDDEN>
Subject: Re: [bug#48696] [PATCH 2/3] doc: Add "Addressing Mistakes" section.
References: <20210527123554.4267-1-ludo@HIDDEN>
 <20210527123554.4267-2-ludo@HIDDEN> <87y2c0f0i4.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 10 Prairial an 229 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Sat, 29 May 2021 12:22:06 +0200
In-Reply-To: <87y2c0f0i4.fsf@HIDDEN> (Christopher Baines's message of
 "Thu, 27 May 2021 20:19:15 +0100")
Message-ID: <87eedpet69.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Chris,

Christopher Baines <mail@HIDDEN> skribis:

> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

[...]

>> +The Guix project values friendly cooperation and a constant effort to
>> +focus on the way forward when issues arise.  Committers should lead by
>> +example, notably as a way to encourage contributors and contributors to
>> +be.  Blame as well as defensiveness do not have their place in Guix when
>> +addressing genuine mistakes.
>
> I too would like to see less blame, but one factor is how things are
> framed and the language used.

Point taken!

> On the language here, "mistake" is a word I would generally avoid if the
> aim is avoid blaming someone, since mistakes are made by a person or set
> of people. I'd prefer a term like "problem", since I don't perceieve
> that as directly linked to a person or set of people.
>
> On the bit about the "person who pushed the faulty commits" (so, person
> to blame...) I'd much prefer an emphisis on group responsibility to
> mitigate the impact of problems quickly, and understand the factors that
> led to that problems in the first place. That avoids assigning blame,
> rather than the process pushing responsibility to the person to blame
> ("person who pushed the faulty commit(s)").

I get what you say and very much like the idea of focusing on group
responsibility.

There=E2=80=99s blame, and there=E2=80=99s accountability.  I see group res=
ponsibility
in setting up processes and carrying out proper peer review to avoid
problems.  I see accountability when it comes to commits actually
pushed=E2=80=94in the end, it=E2=80=99s one person running =E2=80=98git pus=
h=E2=80=99.  In my view,
=E2=80=9Cmistake=E2=80=9D can be a way to name a =E2=80=9Cproblem=E2=80=9D =
that someone created and is
accountable for (Jelle wrote a nice message on this topic a while back).
This is getting a bit philosophical though, and I=E2=80=99m not sure my
understanding of English is good enough to go any further.  :-)

I think you have a point though.  Could you propose different wording
for this section?

(My goal for this section was to (1) spell out circumstances that may
lead to reverts, (2) explain the implications of committer
accountability, and (3) define our community standards in terms of
focusing on addressing issues and not on blaming individuals.)

> On this same thread, I'd like to see less blaming in the form of asking
> people to "explain". When there's a problem, and you ask someone to
> explain, I would interpret that as "I'm blaming you for this, please
> give your account of how the mistake was made", to which the person can
> either answer explaining the details as to why they are to blame, or can
> disagree with the implicit assertion that they are to blame. To avoid
> assigning blame, one can just ask someone to "describe" what happened,
> which I wouldn't interpret as being loaded with the same implicit
> assertion.

I agree with what you write in general, though my understanding is that
you=E2=80=99re not referring to the text in this patch, right?

Thanks for your feedback,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 29 May 2021 09:58:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 29 05:58:23 2021
Received: from localhost ([127.0.0.1]:56014 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmvjb-0002pe-Gh
	for submit <at> debbugs.gnu.org; Sat, 29 May 2021 05:58:23 -0400
Received: from eggs.gnu.org ([209.51.188.92]:47026)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lmvjZ-0002pR-7o
 for 48696 <at> debbugs.gnu.org; Sat, 29 May 2021 05:58:22 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39806)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmvjT-0000ci-Vq; Sat, 29 May 2021 05:58:15 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=40148 helo=ribbon)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmvjT-0004Km-MB; Sat, 29 May 2021 05:58:15 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Christopher Baines <mail@HIDDEN>
Subject: Re: [bug#48696] [PATCH 3/3] doc: Explain more reasons for commit
 revocation.
References: <20210527123554.4267-1-ludo@HIDDEN>
 <20210527123554.4267-3-ludo@HIDDEN> <87v974ey8y.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 10 Prairial an 229 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Sat, 29 May 2021 11:58:14 +0200
In-Reply-To: <87v974ey8y.fsf@HIDDEN> (Christopher Baines's message of
 "Thu, 27 May 2021 21:07:57 +0100")
Message-ID: <87k0nhg8uh.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Christopher Baines <mail@HIDDEN> skribis:

> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

[...]

>> +Maintainers@footnote{See @uref{https://guix.gnu.org/en/about} for the
>> +current list of maintainers.  You can email them privately at
>> +@email{guix-maintainers@@gnu.org}.} may also revoke an individual's
>> +commit rights, as a last resort, if cooperation with the rest of the
>> +community has caused too much friction---even within the bounds of the
>> +project's code of conduct (@pxref{Contributing}).  They would only do so
>> +after public or private discussion with the individual and a clear
>> +notice.  Examples of behavior that hinders cooperation and could lead to
>> +such a decision include:
>> +
>> +@itemize
>> +@item repeated violation of the commit policy stated above;
>> +@item repeated failure to take peer criticism into account;
>> +@item breaching trust through a series of grave incidents.
>> +@end itemize

[...]

> Since the project code of conduct sets out behavioural standards,
> including mandating "Gracefully accepting constructive criticism" and
> "Showing empathy towards other community members", I think that combined
> with "following the relevant processes" already covers what you're
> setting out here?

Note that the code of conduct does not =E2=80=9Cmandate=E2=80=9D gracefully=
 accepting
constructive criticism; it merely gives it as an example of expected
behavior.

> I was shocked by [1], which from memory is the first time a technical
> measure has been used to push a contributor away from the project (at
> least that's my interpretation of the effect/intent). I think the future
> use of revoking individuals commit access would be good to discuss.
>
> 1: https://lists.gnu.org/archive/html/guix-devel/2021-04/msg00489.html

Yes, it was the first time; it was a tough decision for us
co-maintainers because it was a last resort we were not prepared for.
Part of the reason for this patch is to document this possibility so we
all know what to expect.

> In abstract, in my opinion, I can only think of three scenarios for
> removing someones commit access when they're actively using it:
>
> - Clear violation of the code of conduct

Yes, that=E2=80=99s already covered by the code of conduct.

The section above is explicitly about cases where the individual did not
violate the code of conduct (hence =E2=80=9Ceven within the bounds of the
project's code of conduct=E2=80=9D in the text above), but instead broke
community expectations.

> - Suspected malicious intent

Put this way, the question becomes who is suspecting that.  Instead I
wrote =E2=80=9Cbreaching trust=E2=80=9D in the bullet list above; the inten=
t is to
describe a situation where the individual and other committers no longer
trust each other, there=E2=80=99s no judgment involved.

> - Process problem for giving out commit access

The process for giving commit access is already documented (info "(guix)
Commit Access"); my intent here was not to change it.

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 29 May 2021 09:30:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat May 29 05:30:32 2021
Received: from localhost ([127.0.0.1]:56008 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmvIe-0002D4-5R
	for submit <at> debbugs.gnu.org; Sat, 29 May 2021 05:30:32 -0400
Received: from eggs.gnu.org ([209.51.188.92]:43202)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lmvIc-0002Cp-2p
 for 48696 <at> debbugs.gnu.org; Sat, 29 May 2021 05:30:31 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:39510)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmvIU-0006XX-RE; Sat, 29 May 2021 05:30:22 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=40030 helo=ribbon)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmvIU-0002jR-IW; Sat, 29 May 2021 05:30:22 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Julien Lepiller <julien@HIDDEN>, Maxime Devos <maximedevos@HIDDEN>
Subject: Re: [bug#48696] [PATCH 1/3] doc: Structure the "Commit Access"
 section.
References: <20210527123259.4115-1-ludo@HIDDEN>
 <20210527123554.4267-1-ludo@HIDDEN>
 <8FB0AFE9-B53B-42F7-8635-D6B4DA763FC3@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 10 Prairial an 229 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Sat, 29 May 2021 11:30:20 +0200
In-Reply-To: <8FB0AFE9-B53B-42F7-8635-D6B4DA763FC3@HIDDEN> (Julien
 Lepiller's message of "Thu, 27 May 2021 09:55:37 -0400")
Message-ID: <878s3xhopf.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Julien & Maxime,

Julien Lepiller <julien@HIDDEN> skribis:

>>+@example
>>+git config commit.gpgsign true
>>+git config user.signingkey CABBA6EA1DC0FF33
>>+@end example
>>+
>>+You can prevent yourself from accidentally pushing unsigned commits to
>>+Savannah by using the pre-push Git hook called located at
>>+@file{etc/git/pre-push}:
>
> This sentence sounds weird. Isn't "called" superfluous?

[...]

>> +@example
>> +git config commit.gpgsign true
>> +git config user.signingkey CABBA6EA1DC0FF33
>> +@end example
>
> Is that meant to represent =E2=80=98cabbage and coffee=E2=80=99 in l33t?
> Maybe replace this with something like
>
> +@example
>> +git config commit.gpgsign true
>> +# Substitute the fingerprint of your public PGP key
>> +git config user.signingkey CABBA6EA1DC0FF33
>> +@end example
>
> Basic, I know, but people have to learn the basics from
> somewhere, so maybe best be explicit here.

Yes, that makes sense to me.

Note that this text is not new, the patch merely shuffles it around.
But I agree, I=E2=80=99ll address the two issues above once we=E2=80=99ve a=
greed on the
rest.

>> + [... some newlines after @section{...} ]
>
> These extra newlines could go directly into 'master' I guess.
> The rest of [PATCH 1/3] seems ok to me?

I don=E2=80=99t know.  :-)

Patch #1 just moves text around and adds sectioning.

BTW, the whole patch series targets =E2=80=98master=E2=80=99 (there=E2=80=
=99s no point in
documenting our procedures in a branch other than =E2=80=98master=E2=80=99).

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 27 May 2021 20:08:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 27 16:08:03 2021
Received: from localhost ([127.0.0.1]:52861 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmMIU-0001dd-KP
	for submit <at> debbugs.gnu.org; Thu, 27 May 2021 16:08:02 -0400
Received: from mira.cbaines.net ([212.71.252.8]:51384)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1lmMIS-0001dE-RH
 for 48696 <at> debbugs.gnu.org; Thu, 27 May 2021 16:08:01 -0400
Received: from localhost (unknown [IPv6:2a02:8010:68c1:0:8ac0:b4c7:f5c8:7caa])
 by mira.cbaines.net (Postfix) with ESMTPSA id 0BA1527BC78;
 Thu, 27 May 2021 21:08:00 +0100 (BST)
Received: from capella (localhost [127.0.0.1])
 by localhost (OpenSMTPD) with ESMTP id 954d37c7;
 Thu, 27 May 2021 20:07:59 +0000 (UTC)
References: <20210527123554.4267-1-ludo@HIDDEN>
 <20210527123554.4267-3-ludo@HIDDEN>
User-agent: mu4e 1.4.15; emacs 27.2
From: Christopher Baines <mail@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#48696] [PATCH 3/3] doc: Explain more reasons for commit
 revocation.
In-reply-to: <20210527123554.4267-3-ludo@HIDDEN>
Date: Thu, 27 May 2021 21:07:57 +0100
Message-ID: <87v974ey8y.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> * doc/contributing.texi (Commit Revocation): Expound.
> ---
>  doc/contributing.texi | 21 +++++++++++++++++++++
>  1 file changed, 21 insertions(+)
>
> diff --git a/doc/contributing.texi b/doc/contributing.texi
> index 8308551261..ec649c8e13 100644
> --- a/doc/contributing.texi
> +++ b/doc/contributing.texi
> @@ -1444,6 +1444,27 @@ key removed from @file{.guix-authorizations} after=
 12 months of
>  inactivity; they can ask to regain commit access by emailing the
>  maintainers, without going through the vouching process.
>
> +Maintainers@footnote{See @uref{https://guix.gnu.org/en/about} for the
> +current list of maintainers.  You can email them privately at
> +@email{guix-maintainers@@gnu.org}.} may also revoke an individual's
> +commit rights, as a last resort, if cooperation with the rest of the
> +community has caused too much friction---even within the bounds of the
> +project's code of conduct (@pxref{Contributing}).  They would only do so
> +after public or private discussion with the individual and a clear
> +notice.  Examples of behavior that hinders cooperation and could lead to
> +such a decision include:
> +
> +@itemize
> +@item repeated violation of the commit policy stated above;
> +@item repeated failure to take peer criticism into account;
> +@item breaching trust through a series of grave incidents.
> +@end itemize
> +
> +When maintainers resort to such a decision, they notify developers on
> +@email{guix-devel@@gnu.org}; inquiries may be sent to
> +@email{guix-maintainers@@gnu.org}.  Depending on the situation, the
> +individual may still be welcome to contribute.
> +
>  @subsection Helping Out
>
>  One last thing: the project keeps moving forward because committers not

Since the project code of conduct sets out behavioural standards,
including mandating "Gracefully accepting constructive criticism" and
"Showing empathy towards other community members", I think that combined
with "following the relevant processes" already covers what you're
setting out here?

I was shocked by [1], which from memory is the first time a technical
measure has been used to push a contributor away from the project (at
least that's my interpretation of the effect/intent). I think the future
use of revoking individuals commit access would be good to discuss.

1: https://lists.gnu.org/archive/html/guix-devel/2021-04/msg00489.html

In abstract, in my opinion, I can only think of three scenarios for
removing someones commit access when they're actively using it:

=2D Clear violation of the code of conduct

    I don't think it's helpful to set out stuff about conduct in other
    places, particularly bits about unacceptable conduct. If the code of
    conduct is wrong or not sufficient, it should be revised.

=2D Suspected malicious intent

    Like they didn't just introduce some reference to some dodgy release
    tarball for a package, but it seems like this could have been done
    intentionally.

=2D Process problem for giving out commit access

    There's a process and people involved, so it's fair to say that
    problems can occur. Obviously it's not ideal, but if the process
    wasn't followed correctly, or if it's been updated and in hindsight
    different decisions would have been made, I think that's reason
    enough to apologise, and remove someones commit access.

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQKlBAEBCgCPFiEEPonu50WOcg2XVOCyXiijOwuE9XcFAmCv/B1fFIAAAAAALgAo
aXNzdWVyLWZwckBub3RhdGlvbnMub3BlbnBncC5maWZ0aGhvcnNlbWFuLm5ldDNF
ODlFRUU3NDU4RTcyMEQ5NzU0RTBCMjVFMjhBMzNCMEI4NEY1NzcRHG1haWxAY2Jh
aW5lcy5uZXQACgkQXiijOwuE9XfADg//ZyDdxgEMFtb4gPwTBg+poPMs9UtPffHD
UjvUxLE/tFAVc2XmNbb+y39pvRzoKIvv+LSNyKp+cYHP+7cmZYic4skrrKqqyWG5
vVlxqrLoH5W3WLAofP/mU3WlSuoN3auCzFZbJ4nmL38YL3kzv0T4lHeT2hGH7+fK
+6GeZ6GKZposh4UpABb2M3Q6FRnnIqRlIxHgnG9hg3SKtNF4zPobTeVbxepu5qsx
vXXTeF2XHVTL/P3LyT+iQHXtF8gNJXbBJ4HI8sNhq4FYV76hNtOMIJntxf5UyaH7
oFs3D8tzHTtXU2r7/PS7SM/VluusUsD3fvB8gDdQbtYnxT64SZYQ9TjTGmCxXkCV
Fptn/rJJPSlRHiMniDUu6yCEj/I+ks42ytVusP1hsqHMMRW6iTdVThh22JWnYkNj
2Dcqp1UTYpaWkQIp5BS2FLU0J+PfAxGoX5BWSuNKfJfOg+MznYVB1F2KVBD/w2p0
QmyYfFgFu3azP9E4ENNkCInqg0MDBbBh+Ih2W2YlC6jYY4qA3bC08dc9PNMdneVI
mWCHtKkHqnRFEZHT6ysvt9mYAhPcqmv+U+hFPFTasEqhku2d/2YwHV5BaLVY5Gum
cpqWrVfh+oN3a7KuoHAxOwAv6ZJfxHkaJbx16zwhHfS036lPpTI6RaOLEudL9nJM
qSJ8i/fwYqI=
=W42X
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 27 May 2021 19:19:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 27 15:19:21 2021
Received: from localhost ([127.0.0.1]:52815 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmLXM-0000Pl-U7
	for submit <at> debbugs.gnu.org; Thu, 27 May 2021 15:19:21 -0400
Received: from mira.cbaines.net ([212.71.252.8]:51340)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1lmLXL-0000Pd-Nj
 for 48696 <at> debbugs.gnu.org; Thu, 27 May 2021 15:19:20 -0400
Received: from localhost (unknown [IPv6:2a02:8010:68c1:0:8ac0:b4c7:f5c8:7caa])
 by mira.cbaines.net (Postfix) with ESMTPSA id E7B8B27BC78;
 Thu, 27 May 2021 20:19:18 +0100 (BST)
Received: from capella (localhost [127.0.0.1])
 by localhost (OpenSMTPD) with ESMTP id 3b5f4342;
 Thu, 27 May 2021 19:19:18 +0000 (UTC)
References: <20210527123554.4267-1-ludo@HIDDEN>
 <20210527123554.4267-2-ludo@HIDDEN>
User-agent: mu4e 1.4.15; emacs 27.2
From: Christopher Baines <mail@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: [bug#48696] [PATCH 2/3] doc: Add "Addressing Mistakes" section.
In-reply-to: <20210527123554.4267-2-ludo@HIDDEN>
Date: Thu, 27 May 2021 20:19:15 +0100
Message-ID: <87y2c0f0i4.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> * doc/contributing.texi (Addressing Mistakes): New section.
> ---
>  doc/contributing.texi | 34 ++++++++++++++++++++++++++++++++++
>  1 file changed, 34 insertions(+)
>
> diff --git a/doc/contributing.texi b/doc/contributing.texi
> index 7dc912b4de..8308551261 100644
> --- a/doc/contributing.texi
> +++ b/doc/contributing.texi
> @@ -1402,6 +1402,40 @@ you're confident, it's OK to commit.
>  That last part is subject to being adjusted, allowing individuals to com=
mit
>  directly on non-controversial changes on parts they=E2=80=99re familiar =
with.
>=20=20
> +@subsection Addressing Mistakes
> +
> +We all make mistakes.  We expect peer review (@pxref{Submitting
> +Patches}) and tools such as @command{guix lint} (@pxref{Invoking guix
> +lint}) and the test suite (@pxref{Running the Test Suite}) to catch
> +issues before they are pushed; yet, mistakes might go through---that
> +happens to both newcomers and old-timers, and there is nothing to be
> +ashamed of when it happens.  As a community, we expect committers to
> +recognize and address mistakes as soon as possible.
> +
> +Some mistakes can directly affect all users---for instance because they
> +make @command{guix pull} fail or break core functionality, because they
> +break major packages (at build time or run time), or because they
> +introduce known security vulnerabilities.
> +
> +@cindex reverting commits
> +The person who pushed the faulty commit(s) should be at the forefront to
> +address such an issue in a timely fashion: by pushing a followup commit
> +to fix it (if possible), or by reverting it to leave time to come up
> +with a proper fix, and by communicating with other developers about the
> +problem.
> +
> +If the committer is unavailable to address the issue in time, other
> +committers are entitled to revert the offending commit(s), explaining in
> +the commit log and on the mailing list what the problem was, with the
> +goal of leaving time to the original committer and author(s) to propose
> +a way forward.
> +
> +The Guix project values friendly cooperation and a constant effort to
> +focus on the way forward when issues arise.  Committers should lead by
> +example, notably as a way to encourage contributors and contributors to
> +be.  Blame as well as defensiveness do not have their place in Guix when
> +addressing genuine mistakes.

I too would like to see less blame, but one factor is how things are
framed and the language used.

On the language here, "mistake" is a word I would generally avoid if the
aim is avoid blaming someone, since mistakes are made by a person or set
of people. I'd prefer a term like "problem", since I don't perceieve
that as directly linked to a person or set of people.

On the bit about the "person who pushed the faulty commits" (so, person
to blame...) I'd much prefer an emphisis on group responsibility to
mitigate the impact of problems quickly, and understand the factors that
led to that problems in the first place. That avoids assigning blame,
rather than the process pushing responsibility to the person to blame
("person who pushed the faulty commit(s)").

On this same thread, I'd like to see less blaming in the form of asking
people to "explain". When there's a problem, and you ask someone to
explain, I would interpret that as "I'm blaming you for this, please
give your account of how the mistake was made", to which the person can
either answer explaining the details as to why they are to blame, or can
disagree with the implicit assertion that they are to blame. To avoid
assigning blame, one can just ask someone to "describe" what happened,
which I wouldn't interpret as being loaded with the same implicit
assertion.

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQKlBAEBCgCPFiEEPonu50WOcg2XVOCyXiijOwuE9XcFAmCv8LNfFIAAAAAALgAo
aXNzdWVyLWZwckBub3RhdGlvbnMub3BlbnBncC5maWZ0aGhvcnNlbWFuLm5ldDNF
ODlFRUU3NDU4RTcyMEQ5NzU0RTBCMjVFMjhBMzNCMEI4NEY1NzcRHG1haWxAY2Jh
aW5lcy5uZXQACgkQXiijOwuE9Xc48A//YgEpbNOW8DOT17E3DEYQm2u4ci+ChAB/
rmQ9fROQ7UYeB5Kki7TTKrPy25F8Gd+wimkwNvBEHp12drxemTlzKGyXK8nIBLwz
ruW0kb9+FnNtloVsMYKfpZ1wNM6UIaTqv+kOUm0Y24oXuMS+5J4pQNtoqsK0EHsw
qNybzVCHhOgPMFJpbmcTP0Kl2aGY3P4FUo3HeBZUbGiyvezoUvIPVZvyJFwBnn9W
k2BDIm/yDrEY1xJmvZs7LcSL+SOr3yXF59koF3PbUmy6dOfQCJvkPizIBQOd7iET
90Bxy7tU60kXQ5ZRvUJVxV17NT143zdRp4RHj3WFkDbQ09WqLKwSyODQyATFXSFY
ERwvWSnntjtdy4unOBGLmR3Dz6WcaA6IC31HyxPRHxgT9b8R9hG4oTzJP5MsNvBc
oqsYb01V7xoumFz/yXw4avsiEL91mfORpfrkxseIAO5zg1BakkfFtKrj7WmmZzjm
5bJ6DEr+4WAePzoOCTcyC9iJz9bcsuTw+3buvYTbmp5I4yJa/9HRkUAAELVrBqky
/eTPGnLXLVDj4lP/WrYY/xjvojeUEJiA3UL4dQRX0D5WaLUd2p9m7PPs9b+JVt0t
Gwoluc409QRp+XvVISw+EDJvnlWA9aUy/cT3jls+ltHnYFd6K43Fkq1ALVuYkl3q
mA3obbgRte0=
=RVx2
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 27 May 2021 19:13:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 27 15:13:16 2021
Received: from localhost ([127.0.0.1]:52805 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmLRU-0000Fw-1f
	for submit <at> debbugs.gnu.org; Thu, 27 May 2021 15:13:16 -0400
Received: from albert.telenet-ops.be ([195.130.137.90]:42066)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1lmLRR-0000Fl-UK
 for 48696 <at> debbugs.gnu.org; Thu, 27 May 2021 15:13:14 -0400
Received: from ptr-bvsjgyjmffd7q9timvx.18120a2.ip6.access.telenet.be
 ([IPv6:2a02:1811:8c09:9d00:aaf1:9810:a0b8:a55d])
 by albert.telenet-ops.be with bizsmtp
 id 9vDC2500D0mfAB406vDCKV; Thu, 27 May 2021 21:13:12 +0200
Message-ID: <1e92fa266926fc0bba560f9775727e518f8f9a9e.camel@HIDDEN>
Subject: Re: [bug#48696] [PATCH 3/3] doc: Explain more reasons for commit
 revocation.
From: Maxime Devos <maximedevos@HIDDEN>
To: Ludovic =?ISO-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, 48696 <at> debbugs.gnu.org
Date: Thu, 27 May 2021 21:13:12 +0200
In-Reply-To: <20210527123554.4267-3-ludo@HIDDEN>
References: <20210527123554.4267-1-ludo@HIDDEN>
 <20210527123554.4267-3-ludo@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-aLyv8LnqiELrGAhIW8Jv"
User-Agent: Evolution 3.34.2 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r21;
 t=1622142792; bh=2iZe7DaP8X0N3gBpUZqEmaktWmbyRKAlDfQq51Tkbas=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=eNDMUybky0EuWymOHDarsmMl5CcXNAMyGqF7L/LOAfhzBo9frNUmLm6b2o1nWdad/
 mHmd9NDclH+qipOD6NS75F3sODGiGTvZW8aZtWOXIEdQUnngwC0SCo1wAKW4Udx83X
 Il6hWbEozqvFiYWMCvHq8M5YM0IxO8fDtbpaoo3amSBOTbGaDiwn4ifPHFH5eWJm7c
 FuLkGPu7fP4rNIYcSoM/RhhwQ01s9PdplaPMKuf2d2T61ZisYgTpDgovUi35BF167f
 OTixH/bl0+r3BaH0JmxAmAz96PFJ9l0o0MtJGUDWvY9Re1Yoy66klsW0Gt8p5bZUdp
 tFV5991qF8/Ng==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 48696
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-aLyv8LnqiELrGAhIW8Jv
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

PATCH 2/3 and PATCH 3/3 also seem good to me.

Greetings,
Maxime.

--=-aLyv8LnqiELrGAhIW8Jv
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYK/vSBccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7ggfAP9eO0a/rRsugyGa2W7KVI7VTrOt
njXQUh5O6bD4jlf2xwD/bdy/h2XHO/CB01P6j03dZjS0Y/aRFmloRJCYPqTT5QM=
=MDbW
-----END PGP SIGNATURE-----

--=-aLyv8LnqiELrGAhIW8Jv--





Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 27 May 2021 19:10:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 27 15:10:09 2021
Received: from localhost ([127.0.0.1]:52796 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmLOT-0000B2-CA
	for submit <at> debbugs.gnu.org; Thu, 27 May 2021 15:10:09 -0400
Received: from michel.telenet-ops.be ([195.130.137.88]:48020)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maximedevos@HIDDEN>) id 1lmLOR-0000Aq-DB
 for 48696 <at> debbugs.gnu.org; Thu, 27 May 2021 15:10:08 -0400
Received: from ptr-bvsjgyjmffd7q9timvx.18120a2.ip6.access.telenet.be
 ([IPv6:2a02:1811:8c09:9d00:aaf1:9810:a0b8:a55d])
 by michel.telenet-ops.be with bizsmtp
 id 9vA52500F0mfAB406vA5fL; Thu, 27 May 2021 21:10:05 +0200
Message-ID: <53c9218bbf5b72e0b159014e424aeb8782d4d457.camel@HIDDEN>
Subject: Re: [bug#48696] [PATCH 1/3] doc: Structure the "Commit Access"
 section.
From: Maxime Devos <maximedevos@HIDDEN>
To: Ludovic =?ISO-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, 48696 <at> debbugs.gnu.org
Date: Thu, 27 May 2021 21:10:05 +0200
In-Reply-To: <20210527123554.4267-1-ludo@HIDDEN>
References: <20210527123259.4115-1-ludo@HIDDEN>
 <20210527123554.4267-1-ludo@HIDDEN>
Content-Type: multipart/signed; micalg="pgp-sha512";
 protocol="application/pgp-signature"; boundary="=-IvrOrco/8VoSXyaDhB1/"
User-Agent: Evolution 3.34.2 
MIME-Version: 1.0
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=telenet.be; s=r21;
 t=1622142605; bh=48HE9x4MrXtrUYeBLZhE1swdmdJm/Sxqa7Mbnv8SkNM=;
 h=Subject:From:To:Date:In-Reply-To:References;
 b=VbFMryLQY9pH5pVZE1OIdIl4BVPGIz1gGPV1yDjwAP2OmQzMfiboBymyPRqGh5ECD
 2B0DDQi74QElqLVgJLvNnkTGoe+0ejOQW6hXLgJacpQss4k8lR1HXEiZUBg3eApHC2
 49ZXq26st2UHX1wAv7EeJI+lF+pe5svfCUcilnVbhP3YQi9s5MY7oZUgrjC5B3plZP
 3NszAmnNcZTXE8wqn5zMWsmpAzBHxKT35k5Shdhtf+N+InQ8bi1j6t/aLKwJTAycGV
 QlbBuH1SRFqxxGxBKOs2flO87RT8b4ht43WBS4JOTJyQ336Zl8jzDKkqeBbE7f1/FE
 NcFVFcE1N+OOQ==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 48696
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)


--=-IvrOrco/8VoSXyaDhB1/
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Ludovic Court=C3=A8s schreef op do 27-05-2021 om 14:35 [+0200]:
> +All commits that are pushed to the central repository on Savannah must
> +be signed with an OpenPGP key, and the public key should be uploaded to
> +your user account on Savannah and to public key servers, such as
> +@code{keys.openpgp.org}.  To configure Git to automatically sign
> +commits, run:
> +
> +@example
> +git config commit.gpgsign true
> +git config user.signingkey CABBA6EA1DC0FF33
> +@end example

Is that meant to represent =E2=80=98cabbage and coffee=E2=80=99 in l33t?
Maybe replace this with something like

+@example
> +git config commit.gpgsign true
> +# Substitute the fingerprint of your public PGP key
> +git config user.signingkey CABBA6EA1DC0FF33
> +@end example

Basic, I know, but people have to learn the basics from
somewhere, so maybe best be explicit here.

> + [... some newlines after @section{...} ]

These extra newlines could go directly into 'master' I guess.
The rest of [PATCH 1/3] seems ok to me?

Greetings,
Maxime.

--=-IvrOrco/8VoSXyaDhB1/
Content-Type: application/pgp-signature; name="signature.asc"
Content-Description: This is a digitally signed message part
Content-Transfer-Encoding: 7bit

-----BEGIN PGP SIGNATURE-----

iI0EABYKADUWIQTB8z7iDFKP233XAR9J4+4iGRcl7gUCYK/ujRccbWF4aW1lZGV2
b3NAdGVsZW5ldC5iZQAKCRBJ4+4iGRcl7jmZAQD7TBUVWashoIa/4RIpvybic5d5
ijDr/rwVbqww95XoCgD+KNwzET8g3Dw9rsMSmO+g5wS3mmvf0KVNSdPPYQlOTwM=
=FryL
-----END PGP SIGNATURE-----

--=-IvrOrco/8VoSXyaDhB1/--





Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 27 May 2021 14:16:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 27 10:16:38 2021
Received: from localhost ([127.0.0.1]:52471 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmGoP-0004vg-UB
	for submit <at> debbugs.gnu.org; Thu, 27 May 2021 10:16:38 -0400
Received: from out3-smtp.messagingengine.com ([66.111.4.27]:57107)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <leo@HIDDEN>) id 1lmGoO-0004vT-MJ
 for 48696 <at> debbugs.gnu.org; Thu, 27 May 2021 10:16:37 -0400
Received: from compute3.internal (compute3.nyi.internal [10.202.2.43])
 by mailout.nyi.internal (Postfix) with ESMTP id 45FC65C0117;
 Thu, 27 May 2021 10:16:31 -0400 (EDT)
Received: from mailfrontend1 ([10.202.2.162])
 by compute3.internal (MEProxy); Thu, 27 May 2021 10:16:31 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=famulari.name;
 h=date:from:to:cc:subject:message-id:references:mime-version
 :content-type:content-transfer-encoding:in-reply-to; s=mesmtp;
 bh=sFf1Uc8mnCdrYQkkabWLBUXGt6Z287hASJRTrzlnrw0=; b=BiH1zliWK1KN
 6DbmobcJN8wK6p0n+ldXtIN2AB0qHtJbBWu4pnrryV1yIk9BDFnJHxzPmSGAZzQE
 4t6k5tU1YkPkc3Zzx1gUAnwPM11zS+YxsjV448ZPG2EjiY2gL3YO9JG/UcuVyBA/
 KlucHR9ENwt9a43p6asO8ZbyhRsGoYU=
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-transfer-encoding:content-type
 :date:from:in-reply-to:message-id:mime-version:references
 :subject:to:x-me-proxy:x-me-proxy:x-me-sender:x-me-sender
 :x-sasl-enc; s=fm2; bh=sFf1Uc8mnCdrYQkkabWLBUXGt6Z287hASJRTrzlnr
 w0=; b=haYQXf9CPWt4zXJgrUCjJiVbWNzOpupvGpKiNTlAitUPFoxkl3kuVFPit
 cgR0deQjO5W3A/+LrjS0z8aQImWIdnZ9NWrcUowSEpMoWmzP/CoPgfvDMfYE9dnx
 m9AZh3kszm0HKgLJ8rkxEgbHEYSH9Qg7txNpJg/dbw6GOEsqgAzZqEAXnjA8k4BG
 dpk4mbh1AsitM3d/o5cEnpOlTuOepFeyXN6JlfHNGe3SzGcdMrMOmIGDiqK69hSk
 GbfhDgY5SDHdTIi3RXp2QxxpeXKdA6yQJmgHdbffo3XqbLe3BPq6Y7YStDVzZnEQ
 790LQtumBWXC/2khV4xf8Bon9tFTA==
X-ME-Sender: <xms:v6mvYHvJheZGyOJKszZuihO5uown2PTkQE68Mw_i3nLhjqgIf8d8rg>
 <xme:v6mvYIdnVQmJSrimWt1svsjtgfX5OGS7bCZiTAKzzIEzaEEYxJca-lCjf2NQ8cSEq
 uchZsF8C5T-mVYQTQ>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgeduledrvdekhedgjeehucetufdoteggodetrfdotf
 fvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfqfgfvpdfurfetoffkrfgpnffqhgen
 uceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmne
 cujfgurhepfffhvffukfhfgggtugfgjgesthekredttddtjeenucfhrhhomhepnfgvohcu
 hfgrmhhulhgrrhhiuceolhgvohesfhgrmhhulhgrrhhirdhnrghmvgeqnecuggftrfgrth
 htvghrnhepgeejgeeghedtudfgffdutddvffefffejkeffffevffehgedvvdeutdffkeej
 jeejnecukfhppedutddtrdduuddrudeiledruddukeenucevlhhushhtvghrufhiiigvpe
 dtnecurfgrrhgrmhepmhgrihhlfhhrohhmpehlvghosehfrghmuhhlrghrihdrnhgrmhgv
X-ME-Proxy: <xmx:v6mvYKy2NC6A2uMmeaJZ3XTcLAYVBxE4T_ffD5CBfGtpn3_yIvVAag>
 <xmx:v6mvYGO7A9yqz9BN3oB92JxA13WgCeN0f-Q9soJ4o--MPbSpUziMYQ>
 <xmx:v6mvYH9_ed3y0L0Fyx1wShWh1kDWiy-DVvxBjbV8s4VNEK4weI40AA>
 <xmx:v6mvYEJkln4fBS_eFdmjn3IJHI7cUqvzvtONgs1AoV9c-qKClrL_Xw>
Received: from localhost (pool-100-11-169-118.phlapa.fios.verizon.net
 [100.11.169.118]) by mail.messagingengine.com (Postfix) with ESMTPA;
 Thu, 27 May 2021 10:16:30 -0400 (EDT)
Date: Thu, 27 May 2021 10:16:28 -0400
From: Leo Famulari <leo@HIDDEN>
To: Ludovic =?iso-8859-1?Q?Court=E8s?= <ludo@HIDDEN>
Subject: Re: [bug#48696] [PATCH 0/3] Documenting commit reverts and revocation
Message-ID: <YK+pvNseB4Oc05Qc@HIDDEN>
References: <20210527123259.4115-1-ludo@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: 8bit
In-Reply-To: <20210527123259.4115-1-ludo@HIDDEN>
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 48696
Cc: 48696 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On Thu, May 27, 2021 at 02:32:59PM +0200, Ludovic Courtès wrote:
> Hello Guix!
> 
> Attached is an attempt to:
> 
>   1. Structure the “Commit Access” section of the manual;
> 
>   2. Document how to address committers’ mistakes, when to revert
>      commits;
> 
>   3. Explain under what circumstances maintainers may revoke commit
>      rights.
> 
> It essentially codifies unwritten rules, but as always, I think it’s
> better to be explicit about the rules and community expectations.
> 
> Let me know what you think!  I propose to leave a comment period
> of at least one week, possibly iterating with new versions.

Thanks for putting this together. It looks good to me!




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 27 May 2021 13:55:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 27 09:55:51 2021
Received: from localhost ([127.0.0.1]:52452 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmGUJ-0004Rf-7S
	for submit <at> debbugs.gnu.org; Thu, 27 May 2021 09:55:51 -0400
Received: from lepiller.eu ([89.234.186.109]:38550)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <julien@HIDDEN>) id 1lmGUG-0004RR-S5
 for 48696 <at> debbugs.gnu.org; Thu, 27 May 2021 09:55:50 -0400
Received: from lepiller.eu (localhost [127.0.0.1])
 by lepiller.eu (OpenSMTPD) with ESMTP id 7cac0340;
 Thu, 27 May 2021 13:55:46 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed; d=lepiller.eu; h=date
 :in-reply-to:references:mime-version:content-type
 :content-transfer-encoding:subject:to:from:message-id; s=dkim;
 bh=K/VXSVT6cS+nzYt9VLZMswrOCy8nCwnrU9C7ujvbtEI=; b=I9GUCPvgRLUR
 GSDL0wSwotVuUZDXuwS+jbQEVIVlGn7kCYqmVSV6fhZIMeOCvMM0tFadpCultLNU
 F4iFO4IPxp4lwAvuXuz1jyYN4l7RWWyuLjH/Obo1L1evYi9c9hKYqS2aVHEC5bj9
 FcFZ0q0X6JraE4gSYVIC7DqSW+6Kk8evvH1FzqL9QQ8cr0c99lCTjtovW5JX+jR4
 x0GjP37lHMKBrQUuaqxqF+UNLgPoS62mgZfCXTngb+vYLiMHH4LUti4wCsPW5/fu
 Eufk6CTNt/f4GrTzUWn0UAIzFqxSb6hAZyAAre1IxHu/niFddf8MXKfOAf3s/f4d
 lss7AK97iQ==
Received: by lepiller.eu (OpenSMTPD) with ESMTPSA id 98035e2e
 (TLSv1.2:ECDHE-RSA-AES256-GCM-SHA384:256:NO); 
 Thu, 27 May 2021 13:55:46 +0000 (UTC)
Date: Thu, 27 May 2021 09:55:37 -0400
User-Agent: K-9 Mail for Android
In-Reply-To: <20210527123554.4267-1-ludo@HIDDEN>
References: <20210527123259.4115-1-ludo@HIDDEN>
 <20210527123554.4267-1-ludo@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
 charset=utf-8
Content-Transfer-Encoding: quoted-printable
Subject: Re: [bug#48696] [PATCH 1/3] doc: Structure the "Commit Access"
 section.
To: =?ISO-8859-1?Q?Ludovic_Court=E8s?= <ludo@HIDDEN>,48696 <at> debbugs.gnu.org
From: Julien Lepiller <julien@HIDDEN>
Message-ID: <8FB0AFE9-B53B-42F7-8635-D6B4DA763FC3@HIDDEN>
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 48696
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)



Le 27 mai 2021 08:35:52 GMT-04:00, "Ludovic Court=C3=A8s" <ludo@gnu=2Eorg>=
 a =C3=A9crit :
>* doc/contributing=2Etexi (Commit Access): Add introduction and section
>heading=2E  Separate OpenPGP setup from commit policy=2E
>---
> doc/contributing=2Etexi | 59 ++++++++++++++++++++++++++++---------------
> 1 file changed, 38 insertions(+), 21 deletions(-)
>
>diff --git a/doc/contributing=2Etexi b/doc/contributing=2Etexi
>index cfcae22502=2E=2E7dc912b4de 100644
>--- a/doc/contributing=2Etexi
>+++ b/doc/contributing=2Etexi
>@@ -1258,8 +1258,19 @@ this nifty tool!
> @section Commit Access
>=20
> @cindex commit access, for developers
>-For frequent contributors, having write access to the repository is
>-convenient=2E  When you deem it necessary, consider applying for commit
>+Everyone can contribute to Guix without having commit access
>+(@pxref{Submitting Patches})=2E  However, for frequent contributors,
>+having write access to the repository can be convenient=2E  Commit
>access
>+should not be thought of as a ``badge of honor'' but rather as a
>+responsibility a contributor is willing to take to help the project=2E
>+
>+The following sections explain how to get commit access, how to be
>ready
>+to push commits, and the policies and community expectations for
>commits
>+pushed upstream=2E
>+
>+@subsection Applying for Commit Access
>+
>+When you deem it necessary, consider applying for commit
> access by following these steps:
>=20
> @enumerate
>@@ -1331,6 +1342,27 @@ review and merging system, which, as a
>consequence, may lead us to have
> fewer people with commit access to the main repository=2E  Stay tuned!
> @end quotation
>=20
>+All commits that are pushed to the central repository on Savannah must
>+be signed with an OpenPGP key, and the public key should be uploaded
>to
>+your user account on Savannah and to public key servers, such as
>+@code{keys=2Eopenpgp=2Eorg}=2E  To configure Git to automatically sign
>+commits, run:
>+
>+@example
>+git config commit=2Egpgsign true
>+git config user=2Esigningkey CABBA6EA1DC0FF33
>+@end example
>+
>+You can prevent yourself from accidentally pushing unsigned commits to
>+Savannah by using the pre-push Git hook called located at
>+@file{etc/git/pre-push}:

This sentence sounds weird=2E Isn't "called" superfluous?

>+
>+@example
>+cp etc/git/pre-push =2Egit/hooks/pre-push
>+@end example
>+
>+@subsection Commit Policy
>+
> If you get commit access, please make sure to follow
> the policy below (discussions of the policy can take place on
> @email{guix-devel@@gnu=2Eorg})=2E
>@@ -1349,25 +1381,6 @@ mailing list for commit notifications
>(@email{guix-commits@@gnu=2Eorg}),
> so people can notice=2E  Before pushing your changes, make sure to run
> @code{git pull --rebase}=2E
>=20
>-All commits that are pushed to the central repository on Savannah must
>-be signed with an OpenPGP key, and the public key should be uploaded
>to
>-your user account on Savannah and to public key servers, such as
>-@code{keys=2Eopenpgp=2Eorg}=2E  To configure Git to automatically sign
>-commits, run:
>-
>-@example
>-git config commit=2Egpgsign true
>-git config user=2Esigningkey CABBA6EA1DC0FF33
>-@end example
>-
>-You can prevent yourself from accidentally pushing unsigned commits to
>-Savannah by using the pre-push Git hook called located at
>-@file{etc/git/pre-push}:
>-
>-@example
>-cp etc/git/pre-push =2Egit/hooks/pre-push
>-@end example
>-
> When pushing a commit on behalf of somebody else, please add a
> @code{Signed-off-by} line at the end of the commit log message---e=2Eg=
=2E,
> with @command{git am --signoff}=2E  This improves tracking of who did
>@@ -1389,12 +1402,16 @@ you're confident, it's OK to commit=2E
>That last part is subject to being adjusted, allowing individuals to
>commit
> directly on non-controversial changes on parts they=E2=80=99re familiar =
with=2E
>=20
>+@subsection Commit Revocation
>+
> In order to reduce the possibility of mistakes, committers will have
>their Savannah account removed from the Guix Savannah project and their
> key removed from @file{=2Eguix-authorizations} after 12 months of
> inactivity; they can ask to regain commit access by emailing the
> maintainers, without going through the vouching process=2E
>=20
>+@subsection Helping Out
>+
>One last thing: the project keeps moving forward because committers not
> only push their own awesome changes, but also offer some of their time
> @emph{reviewing} and pushing other people's changes=2E  As a committer,




Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 27 May 2021 12:36:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 27 08:36:26 2021
Received: from localhost ([127.0.0.1]:50847 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmFFS-0006CM-0n
	for submit <at> debbugs.gnu.org; Thu, 27 May 2021 08:36:26 -0400
Received: from eggs.gnu.org ([209.51.188.92]:39154)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lmFFQ-0006C0-Es
 for 48696 <at> debbugs.gnu.org; Thu, 27 May 2021 08:36:24 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42910)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmFFL-0006Yr-7k; Thu, 27 May 2021 08:36:19 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=40496 helo=gnu.org)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmFFB-0005Bm-Nm; Thu, 27 May 2021 08:36:11 -0400
From: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
To: 48696 <at> debbugs.gnu.org
Subject: [PATCH 3/3] doc: Explain more reasons for commit revocation.
Date: Thu, 27 May 2021 14:35:54 +0200
Message-Id: <20210527123554.4267-3-ludo@HIDDEN>
X-Mailer: git-send-email 2.31.1
In-Reply-To: <20210527123554.4267-1-ludo@HIDDEN>
References: <20210527123554.4267-1-ludo@HIDDEN>
MIME-Version: 1.0
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

* doc/contributing.texi (Commit Revocation): Expound.
---
 doc/contributing.texi | 21 +++++++++++++++++++++
 1 file changed, 21 insertions(+)

diff --git a/doc/contributing.texi b/doc/contributing.texi
index 8308551261..ec649c8e13 100644
--- a/doc/contributing.texi
+++ b/doc/contributing.texi
@@ -1444,6 +1444,27 @@ key removed from @file{.guix-authorizations} after 12 months of
 inactivity; they can ask to regain commit access by emailing the
 maintainers, without going through the vouching process.
 
+Maintainers@footnote{See @uref{https://guix.gnu.org/en/about} for the
+current list of maintainers.  You can email them privately at
+@email{guix-maintainers@@gnu.org}.} may also revoke an individual's
+commit rights, as a last resort, if cooperation with the rest of the
+community has caused too much friction---even within the bounds of the
+project's code of conduct (@pxref{Contributing}).  They would only do so
+after public or private discussion with the individual and a clear
+notice.  Examples of behavior that hinders cooperation and could lead to
+such a decision include:
+
+@itemize
+@item repeated violation of the commit policy stated above;
+@item repeated failure to take peer criticism into account;
+@item breaching trust through a series of grave incidents.
+@end itemize
+
+When maintainers resort to such a decision, they notify developers on
+@email{guix-devel@@gnu.org}; inquiries may be sent to
+@email{guix-maintainers@@gnu.org}.  Depending on the situation, the
+individual may still be welcome to contribute.
+
 @subsection Helping Out
 
 One last thing: the project keeps moving forward because committers not
-- 
2.31.1





Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 27 May 2021 12:36:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 27 08:36:20 2021
Received: from localhost ([127.0.0.1]:50844 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmFFL-0006C1-Ns
	for submit <at> debbugs.gnu.org; Thu, 27 May 2021 08:36:19 -0400
Received: from eggs.gnu.org ([209.51.188.92]:39132)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lmFFJ-0006Bc-N7
 for 48696 <at> debbugs.gnu.org; Thu, 27 May 2021 08:36:17 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42908)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmFFB-0006Tc-EU; Thu, 27 May 2021 08:36:10 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=40496 helo=gnu.org)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmFF7-0005Bm-Tw; Thu, 27 May 2021 08:36:07 -0400
From: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
To: 48696 <at> debbugs.gnu.org
Subject: [PATCH 2/3] doc: Add "Addressing Mistakes" section.
Date: Thu, 27 May 2021 14:35:53 +0200
Message-Id: <20210527123554.4267-2-ludo@HIDDEN>
X-Mailer: git-send-email 2.31.1
In-Reply-To: <20210527123554.4267-1-ludo@HIDDEN>
References: <20210527123554.4267-1-ludo@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

* doc/contributing.texi (Addressing Mistakes): New section.
---
 doc/contributing.texi | 34 ++++++++++++++++++++++++++++++++++
 1 file changed, 34 insertions(+)

diff --git a/doc/contributing.texi b/doc/contributing.texi
index 7dc912b4de..8308551261 100644
--- a/doc/contributing.texi
+++ b/doc/contributing.texi
@@ -1402,6 +1402,40 @@ you're confident, it's OK to commit.
 That last part is subject to being adjusted, allowing individuals to commit
 directly on non-controversial changes on parts they’re familiar with.
 
+@subsection Addressing Mistakes
+
+We all make mistakes.  We expect peer review (@pxref{Submitting
+Patches}) and tools such as @command{guix lint} (@pxref{Invoking guix
+lint}) and the test suite (@pxref{Running the Test Suite}) to catch
+issues before they are pushed; yet, mistakes might go through---that
+happens to both newcomers and old-timers, and there is nothing to be
+ashamed of when it happens.  As a community, we expect committers to
+recognize and address mistakes as soon as possible.
+
+Some mistakes can directly affect all users---for instance because they
+make @command{guix pull} fail or break core functionality, because they
+break major packages (at build time or run time), or because they
+introduce known security vulnerabilities.
+
+@cindex reverting commits
+The person who pushed the faulty commit(s) should be at the forefront to
+address such an issue in a timely fashion: by pushing a followup commit
+to fix it (if possible), or by reverting it to leave time to come up
+with a proper fix, and by communicating with other developers about the
+problem.
+
+If the committer is unavailable to address the issue in time, other
+committers are entitled to revert the offending commit(s), explaining in
+the commit log and on the mailing list what the problem was, with the
+goal of leaving time to the original committer and author(s) to propose
+a way forward.
+
+The Guix project values friendly cooperation and a constant effort to
+focus on the way forward when issues arise.  Committers should lead by
+example, notably as a way to encourage contributors and contributors to
+be.  Blame as well as defensiveness do not have their place in Guix when
+addressing genuine mistakes.
+
 @subsection Commit Revocation
 
 In order to reduce the possibility of mistakes, committers will have
-- 
2.31.1





Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at 48696 <at> debbugs.gnu.org:


Received: (at 48696) by debbugs.gnu.org; 27 May 2021 12:36:14 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 27 08:36:14 2021
Received: from localhost ([127.0.0.1]:50841 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmFFG-0006Bk-Be
	for submit <at> debbugs.gnu.org; Thu, 27 May 2021 08:36:14 -0400
Received: from eggs.gnu.org ([209.51.188.92]:39098)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lmFFE-0006BW-LA
 for 48696 <at> debbugs.gnu.org; Thu, 27 May 2021 08:36:13 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42904)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmFF7-0006R9-Lw; Thu, 27 May 2021 08:36:07 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=40496 helo=gnu.org)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmFF6-0005Bm-8p; Thu, 27 May 2021 08:36:05 -0400
From: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
To: 48696 <at> debbugs.gnu.org
Subject: [PATCH 1/3] doc: Structure the "Commit Access" section.
Date: Thu, 27 May 2021 14:35:52 +0200
Message-Id: <20210527123554.4267-1-ludo@HIDDEN>
X-Mailer: git-send-email 2.31.1
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 48696
Cc: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

* doc/contributing.texi (Commit Access): Add introduction and section
heading.  Separate OpenPGP setup from commit policy.
---
 doc/contributing.texi | 59 ++++++++++++++++++++++++++++---------------
 1 file changed, 38 insertions(+), 21 deletions(-)

diff --git a/doc/contributing.texi b/doc/contributing.texi
index cfcae22502..7dc912b4de 100644
--- a/doc/contributing.texi
+++ b/doc/contributing.texi
@@ -1258,8 +1258,19 @@ this nifty tool!
 @section Commit Access
 
 @cindex commit access, for developers
-For frequent contributors, having write access to the repository is
-convenient.  When you deem it necessary, consider applying for commit
+Everyone can contribute to Guix without having commit access
+(@pxref{Submitting Patches}).  However, for frequent contributors,
+having write access to the repository can be convenient.  Commit access
+should not be thought of as a ``badge of honor'' but rather as a
+responsibility a contributor is willing to take to help the project.
+
+The following sections explain how to get commit access, how to be ready
+to push commits, and the policies and community expectations for commits
+pushed upstream.
+
+@subsection Applying for Commit Access
+
+When you deem it necessary, consider applying for commit
 access by following these steps:
 
 @enumerate
@@ -1331,6 +1342,27 @@ review and merging system, which, as a consequence, may lead us to have
 fewer people with commit access to the main repository.  Stay tuned!
 @end quotation
 
+All commits that are pushed to the central repository on Savannah must
+be signed with an OpenPGP key, and the public key should be uploaded to
+your user account on Savannah and to public key servers, such as
+@code{keys.openpgp.org}.  To configure Git to automatically sign
+commits, run:
+
+@example
+git config commit.gpgsign true
+git config user.signingkey CABBA6EA1DC0FF33
+@end example
+
+You can prevent yourself from accidentally pushing unsigned commits to
+Savannah by using the pre-push Git hook called located at
+@file{etc/git/pre-push}:
+
+@example
+cp etc/git/pre-push .git/hooks/pre-push
+@end example
+
+@subsection Commit Policy
+
 If you get commit access, please make sure to follow
 the policy below (discussions of the policy can take place on
 @email{guix-devel@@gnu.org}).
@@ -1349,25 +1381,6 @@ mailing list for commit notifications (@email{guix-commits@@gnu.org}),
 so people can notice.  Before pushing your changes, make sure to run
 @code{git pull --rebase}.
 
-All commits that are pushed to the central repository on Savannah must
-be signed with an OpenPGP key, and the public key should be uploaded to
-your user account on Savannah and to public key servers, such as
-@code{keys.openpgp.org}.  To configure Git to automatically sign
-commits, run:
-
-@example
-git config commit.gpgsign true
-git config user.signingkey CABBA6EA1DC0FF33
-@end example
-
-You can prevent yourself from accidentally pushing unsigned commits to
-Savannah by using the pre-push Git hook called located at
-@file{etc/git/pre-push}:
-
-@example
-cp etc/git/pre-push .git/hooks/pre-push
-@end example
-
 When pushing a commit on behalf of somebody else, please add a
 @code{Signed-off-by} line at the end of the commit log message---e.g.,
 with @command{git am --signoff}.  This improves tracking of who did
@@ -1389,12 +1402,16 @@ you're confident, it's OK to commit.
 That last part is subject to being adjusted, allowing individuals to commit
 directly on non-controversial changes on parts they’re familiar with.
 
+@subsection Commit Revocation
+
 In order to reduce the possibility of mistakes, committers will have
 their Savannah account removed from the Guix Savannah project and their
 key removed from @file{.guix-authorizations} after 12 months of
 inactivity; they can ask to regain commit access by emailing the
 maintainers, without going through the vouching process.
 
+@subsection Helping Out
+
 One last thing: the project keeps moving forward because committers not
 only push their own awesome changes, but also offer some of their time
 @emph{reviewing} and pushing other people's changes.  As a committer,
-- 
2.31.1





Information forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 27 May 2021 12:33:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu May 27 08:33:16 2021
Received: from localhost ([127.0.0.1]:50835 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lmFCN-000670-UU
	for submit <at> debbugs.gnu.org; Thu, 27 May 2021 08:33:16 -0400
Received: from lists.gnu.org ([209.51.188.17]:39878)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1lmFCM-00066t-BF
 for submit <at> debbugs.gnu.org; Thu, 27 May 2021 08:33:14 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:60350)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ludo@HIDDEN>) id 1lmFCM-0004ct-0l
 for guix-patches@HIDDEN; Thu, 27 May 2021 08:33:14 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42830)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmFCL-00054Q-C4; Thu, 27 May 2021 08:33:13 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=40494 helo=gnu.org)
 by fencepost.gnu.org with esmtpsa
 (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128) (Exim 4.90_1)
 (envelope-from <ludo@HIDDEN>)
 id 1lmFCK-0006Ji-CC; Thu, 27 May 2021 08:33:13 -0400
From: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
To: guix-patches@HIDDEN
Subject: [PATCH 0/3] Documenting commit reverts and revocation
Date: Thu, 27 May 2021 14:32:59 +0200
Message-Id: <20210527123259.4115-1-ludo@HIDDEN>
X-Mailer: git-send-email 2.31.1
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
Cc: =?UTF-8?q?Ludovic=20Court=C3=A8s?= <ludo@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hello Guix!

Attached is an attempt to:

  1. Structure the “Commit Access” section of the manual;

  2. Document how to address committers’ mistakes, when to revert
     commits;

  3. Explain under what circumstances maintainers may revoke commit
     rights.

It essentially codifies unwritten rules, but as always, I think it’s
better to be explicit about the rules and community expectations.

Let me know what you think!  I propose to leave a comment period
of at least one week, possibly iterating with new versions.

Ludo’.

Ludovic Courtès (3):
  doc: Structure the "Commit Access" section.
  doc: Add "Addressing Mistakes" section.
  doc: Explain more reasons for commit revocation.

 doc/contributing.texi | 114 ++++++++++++++++++++++++++++++++++--------
 1 file changed, 93 insertions(+), 21 deletions(-)

-- 
2.31.1





Acknowledgement sent to Ludovic Courtès <ludo@HIDDEN>:
New bug report received and forwarded. Copy sent to guix-patches@HIDDEN. Full text available.
Report forwarded to guix-patches@HIDDEN:
bug#48696; Package guix-patches. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sun, 13 Jun 2021 10:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.